﻿Module Y_alterno_Parabolica
    Public Function Y_a_Parabola(k As Double, y As Double, Q As Double, alpha As Double, theta As Double) As Double
        Dim Yb, Yba, Ybb, fa, fb, fp, yc, kc, i, M, tol As Double
        Dim g As Single = 9.81
        tol = 0.000000000000001
        kc = alpha * Q ^ 2 / (g * Math.Cos(theta))
        yc = Parabola_TC(k, kc)
        If y < yc Then
            Yba = yc + tol
            Ybb = 1000
        ElseIf y > yc Then
            Yba = 0
            Ybb = yc - tol
        ElseIf y = yc Then
            Yba = yc
            Ybb = yc
        End If

        Yb = (Yba + Ybb) / 2

        fa = Energia_Esp(A_yk_parabola(Yba, k), g, Yba, Q, alpha, theta) - Energia_Esp(A_yk_parabola(y, k), g, y, Q, alpha, theta)
        fb = Energia_Esp(A_yk_parabola(Ybb, k), g, Ybb, Q, alpha, theta) - Energia_Esp(A_yk_parabola(y, k), g, y, Q, alpha, theta)
        fp = Energia_Esp(A_yk_parabola(Yb, k), g, Yb, Q, alpha, theta) - Energia_Esp(A_yk_parabola(y, k), g, y, Q, alpha, theta)

        i = 1
        M = 1000
        While Math.Abs(fp) >= tol And i < M
            i = i + 1
            If fb * fp > 0 Then
                Ybb = Yb
            Else
                Yba = Yb
            End If
            Yb = (Yba + Ybb) / 2

            fb = Energia_Esp(A_yk_parabola(Ybb, k), g, Ybb, Q, alpha, theta) - Energia_Esp(A_yk_parabola(y, k), g, y, Q, alpha, theta)
            fp = Energia_Esp(A_yk_parabola(Yb, k), g, Yb, Q, alpha, theta) - Energia_Esp(A_yk_parabola(y, k), g, y, Q, alpha, theta)

        End While

        Y_a_Parabola = Yb
    End Function
End Module
