﻿Imports System.Math
Imports System.Drawing.Drawing2D
Public Class FEV
    Dim b, k, S, Qi, L, qx, n, alpha, theta, br, kr, Sr, az, yi As String
    Dim yc, Ac, Pc, Tc, Qc, Xc, Sc, Rc, kc, Xo, Yo, zzz As Double
    Dim g = 9.81
    Dim dibujo As Graphics
    Dim Yy() As Double
    Dim Xx() As Double
    Dim xce As Integer
    Dim yce As Integer
    '%***********************************************************************************************
    '%----------------------------------CANAL LATERAL ---------------------------------------------
    '%***********************************************************************************************
    ' Datos del canal vertedor
    Private Sub TextBox1_TextChanged(sender As Object, e As EventArgs) Handles TextBox1.TextChanged
        b = Val(TextBox1.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox2_TextChanged(sender As Object, e As EventArgs) Handles TextBox2.TextChanged
        k = Val(TextBox2.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox3_TextChanged(sender As Object, e As EventArgs) Handles TextBox3.TextChanged
        S = Val(TextBox3.Text)
    End Sub
    Private Sub TextBox4_TextChanged(sender As Object, e As EventArgs) Handles TextBox4.TextChanged
        Qi = Val(TextBox4.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox5_TextChanged(sender As Object, e As EventArgs) Handles TextBox5.TextChanged
        qx = Val(TextBox5.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox6_TextChanged(sender As Object, e As EventArgs) Handles TextBox6.TextChanged
        L = Val(TextBox6.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox7_TextChanged(sender As Object, e As EventArgs) Handles TextBox7.TextChanged
        n = Val(TextBox7.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox8_TextChanged(sender As Object, e As EventArgs) Handles TextBox8.TextChanged
        alpha = Val(TextBox8.Text)
        AcceptButton = Button1
    End Sub
    ' Datos de la rápida
    Private Sub TextBox9_TextChanged(sender As Object, e As EventArgs) Handles TextBox9.TextChanged
        br = Val(TextBox9.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox10_TextChanged(sender As Object, e As EventArgs) Handles TextBox10.TextChanged
        kr = Val(TextBox10.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox11_TextChanged(sender As Object, e As EventArgs) Handles TextBox11.TextChanged
        Sr = Val(TextBox11.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox12_TextChanged(sender As Object, e As EventArgs) Handles TextBox12.TextChanged
        az = Val(TextBox12.Text)
        AcceptButton = Button1
    End Sub
    'Condición inicial
    Private Sub TextBox13_Enter(sender As Object, e As EventArgs) Handles TextBox13.Enter
        RadioButton1.Checked = False
        RadioButton1.Checked = True
        yc = Trapecial_TC_EV(b, k, qx, S, n)
        Ac = A_byk_trapecio(b, k, k, yc)
        Pc = P_byk_trapecio(b, k, k, yc)
        Tc = T_byk_trapecio(b, k, k, yc)
        Qc = Math.Sqrt(g * Ac ^ 3 / Tc)
        Xc = (Qc - Qi) / qx
        If Xc < L Then
            Xo = Xc
            Yo = yc
            zzz = 0
        Else
            theta = Math.Atan(Sr)
            kc = alpha * (Qi + qx * L) ^ 2 / (g * Math.Cos(theta))
            yc = Trapecial_TC(br, kr, kr, kc)
            Ac = A_byk_trapecio(b, k, k, yc)
            Pc = P_byk_trapecio(b, k, k, yc)
            Tc = T_byk_trapecio(b, k, k, yc)
            Qc = Math.Sqrt(g * Ac ^ 3 / Tc)
            Xc = (Qc - Qi) / qx
            Xo = L
            Yo = yc + az
            zzz = 1
        End If
        Rc = Ac / Pc
        Sc = (Qc / Ac * n / Rc ^ (2 / 3)) ^ 2
        TextBox13.Text = "Tirante crítico (yc) = " & Str(Math.Round(yc, 4)) & "  m" & vbNewLine & "Ubicación del tirante crítico (Xc) = " & Str(Math.Round(Xc, 4)) & "  m" & vbNewLine & "Gasto crítico (Qc) = " & Str(Math.Round(Qc, 4)) & "  m^3/s/m"

    End Sub
    Private Sub RadioButton1_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton1.CheckedChanged
        yc = Trapecial_TC_EV(b, k, qx, S, n)
        Ac = A_byk_trapecio(b, k, k, yc)
        Pc = P_byk_trapecio(b, k, k, yc)
        Tc = T_byk_trapecio(b, k, k, yc)
        Qc = Math.Sqrt(g * Ac ^ 3 / Tc)
        Xc = (Qc - Qi) / qx
        If Xc < L Then
            Xo = Xc
            Yo = yc
            zzz = 0
        Else
            theta = Math.Atan(Sr)
            kc = alpha * (Qi + qx * L) ^ 2 / (g * Math.Cos(theta))
            yc = Trapecial_TC(br, kr, kr, kc)
            Ac = A_byk_trapecio(b, k, k, yc)
            Pc = P_byk_trapecio(b, k, k, yc)
            Tc = T_byk_trapecio(b, k, k, yc)
            Qc = Math.Sqrt(g * Ac ^ 3 / Tc)
            Xc = (Qc - Qi) / qx
            Xo = L
            Yo = yc + az
            zzz = 1
        End If
        Rc = Ac / Pc
        Sc = (Qc / Ac * n / Rc ^ (2 / 3)) ^ 2
        TextBox13.Text = "Tirante crítico (yc) = " & Str(Math.Round(yc, 4)) & "  m" & vbNewLine & "Ubicación del tirante crítico (Xc) = " & Str(Math.Round(Xc, 4)) & "  m" & vbNewLine & "Gasto crítico (Qc) = " & Str(Math.Round(Qc, 4)) & "  m^3/s/m"
    End Sub
    Private Sub TextBox14_enter(sender As Object, e As EventArgs) Handles TextBox14.Enter
        RadioButton2.Checked = False
        RadioButton2.Checked = True
        yi = Val(TextBox14.Text)
        If zzz = 1 Then
            If yi > yc Then
                Yo = yi
            Else
                MsgBox("El tirante conocido al final del canal, debe ser mayor que el crítico en ese lugar.")
            End If
        End If
    End Sub
    'Cálculo
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        If Xc < 0 Then
            MsgBox("¡Atención! El inicio del cálculo esta fuera del canal aguas arriba.", MsgBoxStyle.Exclamation)
        End If

        DataGridView1.Rows.Clear()
        graficas.Close()
        If RadioButton1.Checked = False And RadioButton2.Checked = False Then
            MsgBox("Favor de indicar la condición inicial")
        Else
            If RadioButton2.Checked = True Then
            Else
                RadioButton1.Checked = False
                RadioButton1.Checked = True
            End If
            FEV_perfil(b, k, L, Xo, Yo, qx, Qi, n, S)
            graficas.Show()
        End If
    End Sub
    '%***********************************************************************************************
    '%-------------------------------------------Ayuda---------------------------------------------
    '%***********************************************************************************************
    Private Sub FEV_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        graficas.Close()
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Manning.Show()
    End Sub
    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles Button12.Click
        Coriolis.Show()
    End Sub
    '%***********************************************************************************************
    '%-------------------------------------------MENU ---------------------------------------------
    '%***********************************************************************************************
    Private Sub AcercaDeToolStripMenuItem_Click_1(sender As Object, e As EventArgs) Handles AcercaDeToolStripMenuItem.Click
        Acerca_de.Show()
    End Sub
    Private Sub CalculadoraToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CalculadoraToolStripMenuItem.Click
        'Ejecutar la Calculadora
        Shell("C:\WINDOWS\system32\calc.exe", AppWinStyle.NormalFocus)
    End Sub
    Private Sub GuradarToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles GuradarToolStripMenuItem.Click
        SaveFileDialog1.ShowDialog()
    End Sub
    Private Sub AbrirToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AbrirToolStripMenuItem.Click
        OpenFileDialog1.ShowDialog()
    End Sub
    Private Sub SaveFileDialog1_FileOk(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles SaveFileDialog1.FileOk
        Dim writer As New IO.StreamWriter(SaveFileDialog1.FileName)
        If Me.TabControl1.SelectedTab Is TabPage1 Then
            writer.Write("*******Flujo espacialmente variado******" & vbNewLine)
            writer.Write("***Datos del canal vertedor trapecial***" & vbNewLine)
            writer.Write("Base (b), m                      " & vbNewLine & TextBox1.Text & vbNewLine)
            writer.Write("Talud (K)                        " & vbNewLine & TextBox2.Text & vbNewLine)
            writer.Write("Pendiente (S), m/m               " & vbNewLine & TextBox3.Text & vbNewLine)
            writer.Write("Gasto inicial (Qi), m^3/s        " & vbNewLine & TextBox4.Text & vbNewLine)
            writer.Write("Gasto unitario (qx), m^3/s/m     " & vbNewLine & TextBox5.Text & vbNewLine)
            writer.Write("Longitud del canal (L), m        " & vbNewLine & TextBox6.Text & vbNewLine)
            writer.Write("Coeficiente de Manning (n)       " & vbNewLine & TextBox7.Text & vbNewLine)
            writer.Write("Coeficiente de coriolis (alpha)  " & vbNewLine & TextBox8.Text & vbNewLine)
            writer.Write("******Datos de la rápida**********" & vbNewLine)
            writer.Write("Base (br), m                      " & vbNewLine & TextBox9.Text & vbNewLine)
            writer.Write("Talud (Kr)                        " & vbNewLine & TextBox10.Text & vbNewLine)
            writer.Write("Pendiente (Sr), m/m               " & vbNewLine & TextBox11.Text & vbNewLine)
            writer.Write("escalón (az), m                   " & vbNewLine & TextBox12.Text & vbNewLine)
            writer.Write("********Condición inicial**********" & vbNewLine)
            writer.Write("Tirante crítico (yc), m            " & vbNewLine & Math.Round(Val(yc), 4) & vbNewLine)
            writer.Write("Ubicación del tirante crítico (Xc) , m      " & vbNewLine & Math.Round(Val(Xc), 4) & vbNewLine)
            writer.Write("Gasto crítico (Qc), m              " & vbNewLine & Math.Round(Val(Qc), 4) & vbNewLine)
            writer.Write("**************Resultados**************" & vbNewLine)
            writer.Write("Pendiente crítica (Sc), m/m      " & vbNewLine & Sc & vbNewLine)
            writer.Write("	X		Y" & vbNewLine)
            For Each row In DataGridView1.Rows
                writer.Write(row.Cells(0).Value & "		" & row.Cells(1).Value & vbNewLine)
            Next
        End If
        writer.Close()
    End Sub
    Private Sub OpenFileDialog1_FileOk(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk
        Dim reader As New IO.StreamReader(OpenFileDialog1.FileName)
        If Me.TabControl1.SelectedTab Is TabPage1 Then
            reader.ReadLine()
            reader.ReadLine()
            reader.ReadLine()
            TextBox1.Text = reader.ReadLine
            reader.ReadLine()
            TextBox2.Text = reader.ReadLine
            reader.ReadLine()
            TextBox3.Text = reader.ReadLine
            reader.ReadLine()
            TextBox4.Text = reader.ReadLine
            reader.ReadLine()
            TextBox5.Text = reader.ReadLine
            reader.ReadLine()
            TextBox6.Text = reader.ReadLine
            reader.ReadLine()
            TextBox7.Text = reader.ReadLine
            reader.ReadLine()
            TextBox8.Text = reader.ReadLine
            reader.ReadLine()
            reader.ReadLine()
            TextBox9.Text = reader.ReadLine
            reader.ReadLine()
            TextBox10.Text = reader.ReadLine
            reader.ReadLine()
            TextBox11.Text = reader.ReadLine
            reader.ReadLine()
            TextBox12.Text = reader.ReadLine
        End If
        reader.Close()
    End Sub
    Private Sub CopiarToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CopiarToolStripMenuItem.Click
        If Me.TabControl1.SelectedTab Is TabPage1 Then
            DataGridView1.SelectAll()
            Clipboard.SetDataObject(Me.DataGridView1.GetClipboardContent())
        End If
    End Sub
    '%-----------------------------------------  Bolqueo de teclas  --------------------------------
    '%Asc(46)= ".", Asc (13)= "enter", Asc(8)= "retroceso", Asc(3)= "ctrl+c (copiar)", Asc(22)="ctrl+v (pegar)", Asc (45)= "-", isnumber= numericos
    '%***********************************************************************************************
    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox2_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox2.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox3_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox3.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox4_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox4.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox5_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox5.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox6_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox6.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox7_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox7.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox8_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox8.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox9_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox9.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox10_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox10.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox11_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox11.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox12_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox12.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub




End Class