﻿Module FEV_trapecial
    Public Function FEV_perfil(b As Double, k As Double, Lv As Double, Xo As Double, Yo As Double, qx As Double, Qi As Double, n As Double, S As Double) As Double()
        Dim Ni, dxx, xi, yi, dy1, dy2, dy, Fdy1, Fdy2, Fdy3, Q1, Q2, dx As Double
        Dim fallo, i, j, r, w As Integer
        Dim g = 9.81              'gravedad
        Dim Y() As Double
        Dim X() As Double
        Dim Yy() As Double
        Dim Xx() As Double
        Dim G1() As Double
        Dim GG() As Double
        Ni = 75
        fallo = 0
        i = 0
        j = 0
        dxx = Int(Lv / Ni)
        xi = Xo
        yi = Yo
        '% Cálculo hacia la derecha --->
        If xi <> Lv Then
            dx = 1
            If (xi + dx) <> Int(xi + dx) Then
                dx = Math.Abs(Int(xi + dx) - xi)
            ElseIf (Xo + dx) > Lv Then
                dx = Lv - Xo
            End If
            dy1 = Yo / 100
            dy2 = 0.03 * dy1
            Q1 = Qi + Xo * qx
            ReDim Preserve X(i)
            ReDim Preserve Y(i)
            ReDim Preserve G1(i)
            X(i) = Xo
            Y(i) = Yo
            G1(i) = Q1
            While fallo = 0
                Fdy1 = FEV_DF(b, k, Yo, dy1, dx, qx, Q1, n, S)
                Fdy2 = FEV_DF(b, k, Yo, dy2, dx, qx, Q1, n, S)
                dy = dy2 - Fdy2 * (dy2 - dy1) / (Fdy2 - Fdy1)
                Fdy3 = FEV_DF(b, k, Yo, dy, dx, qx, Q1, n, S)
                If Math.Abs(Fdy3) <= 0.00001 Then
                    Xo = Xo + dx
                    Yo = Yo + dy
                    Q1 = Qi + Xo * qx
                    dy1 = dy
                    dy2 = dy1 / 2
                    i = i + 1
                    ReDim Preserve X(i)
                    ReDim Preserve Y(i)
                    ReDim Preserve G1(i)
                    X(i) = Xo
                    Y(i) = Yo
                    G1(i) = Q1
                Else
                    dy1 = dy2
                    dy2 = dy
                    Fdy1 = Fdy2
                    Fdy2 = Fdy3
                End If
                dx = dxx
                If (Xo + dx) > Lv Then
                    dx = Lv - Xo
                End If
                If Xo >= Lv Then
                    fallo = 1
                End If
            End While
        End If
        fallo = 0
        '%Cálculo hacia la izquierda <---
        If xi = Lv Or (xi < Lv And xi > 0) Then
            dx = -1
            If (xi + dx) <> Fix(xi + dx) Then
                dx = -Math.Abs(Fix(xi + dx) - xi)
            ElseIf (xi + dx) < 0 Then
                dx = -xi
            End If
            dy1 = -yi / 100
            dy2 = 0.03 * dy1
            Q2 = Qi + xi * qx
            ReDim Preserve Xx(j)
            ReDim Preserve Yy(j)
            ReDim Preserve GG(j)
            Xx(j) = xi
            Yy(j) = yi
            GG(j) = Q2
            While fallo = 0
                Fdy1 = FEV_DF(b, k, yi, dy1, dx, qx, Q2, n, S)
                Fdy2 = FEV_DF(b, k, yi, dy2, dx, qx, Q2, n, S)
                dy = dy2 - Fdy2 * (dy2 - dy1) / (Fdy2 - Fdy1)
                Fdy3 = FEV_DF(b, k, yi, dy, dx, qx, Q2, n, S)
                If Math.Abs(Fdy3) <= 0.00001 Then
                    xi = xi + dx
                    yi = yi + dy
                    Q2 = Qi + xi * qx
                    dy1 = dy
                    dy2 = dy1 / 2
                    j = j + 1
                    ReDim Preserve Xx(j)
                    ReDim Preserve Yy(j)
                    ReDim Preserve GG(j)
                    Xx(j) = xi
                    Yy(j) = yi
                    GG(j) = Q2
                Else
                    dy1 = dy2
                    dy2 = dy
                    Fdy1 = Fdy2
                    Fdy2 = Fdy3
                End If
                dx = -dxx
                If (xi + dx) < 0 Then
                    dx = -xi
                End If
                If xi <= 0 Then
                    fallo = 1
                End If
            End While
        End If
        '%Acomodo de vectores
        ReDim Preserve Xx(j)
        ReDim Preserve Yy(j)
        ReDim Preserve GG(j)
        ReDim Preserve X(i)
        ReDim Preserve Y(i)
        ReDim Preserve G1(i)
        r = j
        For z = 1 To i
            r = r + 1
            ReDim Preserve Xx(r)
            ReDim Preserve Yy(r)
            ReDim Preserve GG(r)
            Xx(r) = X(z)
            Yy(r) = Y(z)
            GG(r) = G1(z)
        Next
        ReDim Preserve X(j)
        ReDim Preserve Y(j)
        ReDim Preserve G1(j)
        For z = 1 To j
            X(z) = Xx(z)
            Y(z) = Yy(z)
            G1(z) = GG(z)
        Next
        w = 0
        For z = j To 1 Step -1
            w = w + 1
            Xx(w) = X(z)
            Yy(w) = Y(z)
            GG(w) = G1(z)
        Next
        For z = 1 To r
            If Xx(z) >= 0 Then
                FEV.DataGridView1.Rows.Add(Math.Round(Xx(z), 4), Math.Round(Yy(z), 4), Math.Round(GG(z), 4))
            End If
        Next
        FEV_perfil = Yy
    End Function
End Module
