﻿Module FGV_dy_circular_Rk
    Public Function FGV_dy_Circular(Q As Double, S As Double, n As Double, D As Double, yf As Double, y1 As Double, Li As Double, h As Double, alpha As Double, theta As Double, perf As String, dibujo As Graphics, xce As Integer, yce As Integer) As Double()
        Dim A, P, T, R, U, Fr, Sf, dydx, K1, k2, k3, k4, y2, y3, y4 As Double
        Dim g As Double = 9.81
        Dim i As Integer = 0
        Dim fallo As Integer = 0
        Dim xx As Double = 0
        Dim Y() As Double
        Dim X() As Double
        Dim Ys() As Double
        Dim Xs() As Double
        '% ***********flujo gradualmente varido por Runge-Kutta dy**********
        While Math.Abs(y1 - yf) > Math.Abs(h) And Math.Abs(y1 - yf) > Math.Abs(0.000001) And y1 < D And i < 100
            ' %*********Cálculo de k1
            A = A_Dy_circulo(D, y1)
            P = P_Dy_Circulo(D, y1)
            T = T_Dy_Circulo(D, y1)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (1 - Fr ^ 2) / (S - Sf)
            K1 = h * dydx
            ' %*********Cálculo de k2
            y2 = y1 + 0.5 * h
            A = A_Dy_circulo(D, y2)
            P = P_Dy_Circulo(D, y2)
            T = T_Dy_Circulo(D, y2)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (1 - Fr ^ 2) / (S - Sf)
            k2 = h * dydx
            ' %*********Cálculo de k3
            y3 = y1 + 0.5 * h
            A = A_Dy_circulo(D, y3)
            P = P_Dy_Circulo(D, y3)
            T = T_Dy_Circulo(D, y3)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (1 - Fr ^ 2) / (S - Sf)
            k3 = h * dydx
            ' %*********Cálculo de k4
            y4 = y1 + h
            A = A_Dy_circulo(D, y4)
            P = P_Dy_Circulo(D, y4)
            T = T_Dy_Circulo(D, y4)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (1 - Fr ^ 2) / (S - Sf)
            k4 = h * dydx
            If (perf = "M2" Or perf = "M1") And K1 > 0 Then
                K1 = K1 * -1
            End If
            If (perf = "M2" Or perf = "M1") And k2 > 0 Then
                k2 = k2 * -1
            End If
            If (perf = "M2" Or perf = "M1") And k3 > 0 Then
                k3 = k3 * -1
            End If
            If (perf = "M2" Or perf = "M1") And k4 > 0 Then
                k4 = k4 * -1
            End If
            '%almacenamiento del tirante y distancia en vectores
            ReDim Preserve X(i)
            ReDim Preserve Y(i)
            ReDim Preserve Xs(i)
            ReDim Preserve Ys(i)
            Y(i) = y1
            X(i) = Li
            Xs(i) = xx
            Ys(i) = Y(i) - xx * (S)
            xx = xx + (1 / 6 * (K1 + 2 * k2 + 2 * k3 + k4))
            Li = Li + 1 / 6 * (K1 + 2 * k2 + 2 * k3 + k4)
            y1 = y4
            FGV.DataGridView2.Rows.Add(Math.Round(X(i), 4), Math.Round(Y(i), 4))
            i = i + 1
        End While
        ReDim Preserve X(i)
        ReDim Preserve Y(i)
        Y(i) = y1
        X(i) = Li
        FGV.DataGridView1.Rows.Add(Math.Round(X(i), 4), Math.Round(Y(i), 4))
        FGV_dy_Circular = Y
        'Llamar a la gráfica
        ReDim Preserve Xs(i - 1)
        ReDim Preserve Ys(i - 1)
        Graf_perfil(Xs, Ys, S, dibujo, xce, yce)
    End Function

End Module
