﻿Module herradura_P_Dy
    Public Function P_Dy_herradura(ByVal D As Double, y As Double) As Double
        Dim P As Double
        Dim Po, y1, y2, y3, P1, P2, P3, x, x1 As Double
        If y > D Then
            P = 0
        Else
            Po = 0.08856217 * D
            If y <= Po Then
                y1 = y
                x = (y1 - D) / D
                P1 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) + 3.141592653589 / 2)
                P2 = 0
                P3 = 0
            ElseIf y > Po And y <= 0.5 * D Then
                y1 = Po
                y2 = y
                x = (y1 - D) / D
                P1 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) + 3.141592653589 / 2)
                x = (2 * y2 - D) / (2 * D)
                x1 = (2 * Po - D) / (2 * D)
                P2 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) - Math.Atan(x1 / Math.Sqrt(-x1 * x1 + 1)))
                P3 = 0
            Else
                y1 = Po
                y2 = 0.5 * D
                y3 = y
                x = (y1 - D) / D
                P1 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) + 3.141592653589 / 2)
                x = (2 * y2 - D) / (2 * D)
                x1 = (2 * Po - D) / (2 * D)
                P2 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) - Math.Atan(x1 / Math.Sqrt(-x1 * x1 + 1)))
                x = (2 * y - D) / D
                P3 = D * Math.Atan(x / Math.Sqrt(-x * x + 1))
            End If
            P = P1 + P2 + P3
        End If
        P_Dy_herradura = P
    End Function
End Module
