﻿Module herradura_R_Dy
    Public Function R_Dy_herradura(ByVal D As Double, y As Double) As Double
        Dim R As Double
        Dim Po, y1, y2, y3, A1, A2, A3, P1, P2, P3, x, x1, A, P As Double
        If y > D Then
            R = 0
        Else
            Po = 0.08856217 * D
            If y <= Po Then
                y1 = y
                x = (y1 - D) / D
                A1 = (y1 - D) * (y1 * (2 * D - y1)) ^ 0.5 + D ^ 2 * Math.Atan(x / Math.Sqrt(-x * x + 1)) + 3.141592653589 * D ^ 2 / 2
                P1 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) + 3.141592653589 / 2)
                A2 = 0
                P2 = 0
                A3 = 0
                P3 = 0
            ElseIf y > Po And y <= 0.5 * D Then
                y1 = Po
                y2 = y
                x = (y1 - D) / D
                A1 = (y1 - D) * (y1 * (2 * D - y1)) ^ 0.5 + D ^ 2 * Math.Atan(x / Math.Sqrt(-x * x + 1)) + 3.141592653589 * D ^ 2 / 2
                P1 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) + 3.141592653589 / 2)
                x = (8 * y2 - 4 * D) / (8 * D)
                x1 = (8 * Po - 4 * D) / (8 * D)
                A2 = (2 * y2 - D) / 4 * (3 * D ^ 2 + 4 * D * y2 - 4 * y2 ^ 2) ^ 0.5 + D ^ 2 * Math.Atan(x / Math.Sqrt(-x * x + 1)) - (2 * Po - D) / 4 * (3 * D ^ 2 + 4 * D * Po - 4 * Po ^ 2) ^ 0.5 - D ^ 2 * Math.Atan(x1 / Math.Sqrt(-x1 * x1 + 1)) - D * (y2 - Po)
                A3 = 0
                x = (2 * y2 - D) / (2 * D)
                x1 = (2 * Po - D) / (2 * D)
                P2 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) - Math.Atan(x1 / Math.Sqrt(-x1 * x1 + 1)))
                P3 = 0
            Else
                y1 = Po
                y2 = 0.5 * D
                y3 = y
                x = (y1 - D) / D
                A1 = (y1 - D) * (y1 * (2 * D - y1)) ^ 0.5 + D ^ 2 * Math.Atan(x / Math.Sqrt(-x * x + 1)) + 3.141592653589 * D ^ 2 / 2
                P1 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) + 3.141592653589 / 2)
                x = (8 * y2 - 4 * D) / (8 * D)
                x1 = (8 * Po - 4 * D) / (8 * D)
                A2 = (2 * y2 - D) / 4 * (3 * D ^ 2 + 4 * D * y2 - 4 * y2 ^ 2) ^ 0.5 + D ^ 2 * Math.Atan(x / Math.Sqrt(-x * x + 1)) - (2 * Po - D) / 4 * (3 * D ^ 2 + 4 * D * Po - 4 * Po ^ 2) ^ 0.5 - D ^ 2 * Math.Atan(x1 / Math.Sqrt(-x1 * x1 + 1)) - D * (y2 - Po)
                x = (2 * y3 - D) / D
                A3 = (2 * y3 - D) / 2 * (D * y3 - y3 ^ 2) ^ 0.5 + D ^ 2 / 4 * Math.Atan(x / Math.Sqrt(-x * x + 1))
                x = (2 * y2 - D) / (2 * D)
                x1 = (2 * Po - D) / (2 * D)
                P2 = 2 * D * (Math.Atan(x / Math.Sqrt(-x * x + 1)) - Math.Atan(x1 / Math.Sqrt(-x1 * x1 + 1)))
                x = (2 * y - D) / D
                P3 = D * Math.Atan(x / Math.Sqrt(-x * x + 1))
            End If
            A = A1 + A2 + A3
            P = P1 + P2 + P3
            R = A / P
        End If
        R_Dy_herradura = R
    End Function
End Module
