﻿Module Parabola_Y_RT
    Public Function Y_RT_parabola(ByVal R As Double, T As Double) As Double
        Dim y, A, P As Double
        Dim x As Double
        Dim tol, fb, fp, y1, y2, R1 As Double
        Dim i, M As Integer

        If R <= 0 Or T <= 0 Then
            y = 0
        Else
            i = 1
            M = 1000
            tol = 0.0000000000001
            'Método de bisección para el cálculo del diámetro
            y1 = tol
            y2 = 100
            'funciones
            y = (y1 + y2) / 2
            '************ y2
            x = 4 * y2 / T
            If x < 1 Then
                P = T + 8 / 3 * y2 ^ 2 / T
                A = 2 / 3 * T * y2
                R1 = A / P
            Else
                P = T / 2 * ((1 + x ^ 2) ^ 0.5 + 1 / x * Math.Log(x + (1 + x ^ 2) ^ 0.5))
                A = 2 / 3 * T * y2
                R1 = A / P
            End If
            fb = R1 - R
            '************ y
            x = 4 * y / T
            If x < 1 Then
                P = T + 8 / 3 * y ^ 2 / T
                A = 2 / 3 * T * y
                R1 = A / P
            Else
                P = T / 2 * ((1 + x ^ 2) ^ 0.5 + 1 / x * Math.Log(x + (1 + x ^ 2) ^ 0.5))
                A = 2 / 3 * T * y
                R1 = A / P
            End If
            fp = R1 - R
            Do While Math.Abs(fp) >= tol And i < M
                i = i + 1
                If (fb * fp) > 0 Then
                    y2 = y
                Else
                    y1 = y
                End If
                'funciones
                y = (y1 + y2) / 2
                '************ y2
                x = 4 * y2 / T
                If x < 1 Then
                    P = T + 8 / 3 * y2 ^ 2 / T
                    A = 2 / 3 * T * y2
                    R1 = A / P
                Else
                    P = T / 2 * ((1 + x ^ 2) ^ 0.5 + 1 / x * Math.Log(x + (1 + x ^ 2) ^ 0.5))
                    A = 2 / 3 * T * y2
                    R1 = A / P
                End If
                fb = R1 - R
                '************ y
                x = 4 * y / T
                If x < 1 Then
                    P = T + 8 / 3 * y ^ 2 / T
                    A = 2 / 3 * T * y
                    R1 = A / P
                Else
                    P = T / 2 * ((1 + x ^ 2) ^ 0.5 + 1 / x * Math.Log(x + (1 + x ^ 2) ^ 0.5))
                    A = 2 / 3 * T * y
                    R1 = A / P
                End If
                fp = R1 - R
            Loop
        End If
        Y_RT_parabola = y
    End Function
End Module
