﻿Imports System.Math
Imports System.Drawing.Drawing2D
Public Class graficas
    Private matriz As Matrix
    Private calidad As SmoothingMode

    Private x1, y1, x2, y2, y11, y22, x11, x22 As Integer
    Private botonPulsado As Boolean

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        calidad = SmoothingMode.HighQuality
    End Sub
    Private Sub ciFuncion_Paint(sender As Object, e As PaintEventArgs) Handles ciFuncion.Paint
        Dim g As Graphics = e.Graphics
        g.Clear(ciFuncion.BackColor)
        Dim i As Integer
        Dim vlong As Integer
        Dim Xxx() As Single
        Dim Yyy() As Single
        'Lectura de los datos de Xxx() y Yyy()
        'Módulo flujo gradualmente variado
        If FGV.TabControl1.SelectedTab Is FGV.TabPage1 Then
            For Each row In FGV.DataGridView1.Rows
                ReDim Preserve Xxx(i)
                ReDim Preserve Yyy(i)
                Xxx(i) = (row.Cells(0).Value)
                Yyy(i) = (row.Cells(1).Value)
                i = i + 1
            Next
        ElseIf FGV.TabControl1.SelectedTab Is FGV.TabPage2 Then
            For Each row In FGV.DataGridView2.Rows
                ReDim Preserve Xxx(i)
                ReDim Preserve Yyy(i)
                Xxx(i) = (row.Cells(0).Value)
                Yyy(i) = (row.Cells(1).Value)
                i = i + 1
            Next
        ElseIf FGV.TabControl1.SelectedTab Is FGV.TabPage3 Then
            For Each row In FGV.DataGridView3.Rows
                ReDim Preserve Xxx(i)
                ReDim Preserve Yyy(i)
                Xxx(i) = (row.Cells(0).Value)
                Yyy(i) = (row.Cells(1).Value)
                i = i + 1
            Next
        ElseIf FGV.TabControl1.SelectedTab Is FGV.TabPage4 Then
            For Each row In FGV.DataGridView4.Rows
                ReDim Preserve Xxx(i)
                ReDim Preserve Yyy(i)
                Xxx(i) = (row.Cells(0).Value)
                Yyy(i) = (row.Cells(1).Value)
                i = i + 1
            Next
        End If
        'Módulo flujo espacialmente variado
        If FEV.TabControl1.SelectedTab Is FEV.TabPage1 Then
            For Each row In FEV.DataGridView1.Rows
                ReDim Preserve Xxx(i)
                ReDim Preserve Yyy(i)
                Xxx(i) = (row.Cells(0).Value)
                Yyy(i) = (row.Cells(1).Value)
                i = i + 1
            Next
        End If

        ReDim Preserve Xxx(i - 4)
        ReDim Preserve Yyy(i - 4)
        i = 1
        vlong = Xxx.Length - 1

        For i = 1 To vlong
            Xxx(i - 1) = Xxx(i)
            Yyy(i - 1) = Yyy(i)
        Next

        ReDim Preserve Xxx(vlong - 1)
        ReDim Preserve Yyy(vlong - 1)
        i = 1

        Dim Xmin, Xmax As Single
        Dim Ymax, Ymin As Single
        vlong = Xxx.Length - 1
        If Xxx(0) > Xxx(vlong) Then
            Xmax = Xxx(0)
            Xmin = Xxx(vlong)
        Else
            Xmax = Xxx(vlong)
            Xmin = Xxx(0)
        End If
        If Yyy(0) > Yyy(vlong) Then
            Ymax = Yyy(0)
            Ymin = Yyy(vlong)
        Else
            Ymax = Yyy(vlong)
            Ymin = Yyy(0)
        End If

        ' matriz vale inicialmente: 1 0 0 1 0 0
        matriz = New Matrix()
        ' Scale modifica los valores primero y cuarto
        matriz.Scale(((ciFuncion.Width - 5) / (Xmax - Xmin)), - _
                     (ciFuncion.Height - 5) / (Ymax - Ymin))
        ' Translate modifica los valores quinto y sexto
        matriz.Translate(-Xmin, -Ymax)

        ' Trazados para los ejes
        Dim EjeX As New GraphicsPath()
        Dim EjeY As New GraphicsPath()
        'EjeX.AddLine(New PointF(Xmin, 0), New PointF(Xmax, 0))
        'EjeY.AddLine(New PointF(0, Ymax), New PointF(0, Ymin))

        ' Trazado para la función
        Dim XAnterior, YAnterior As Single
        'Dim X, Y As Single
        ' Cada segmento en el trazado va desde (XAnterior, YAnterior) a (X, Y)
        Dim Función As New GraphicsPath()
        Dim lápiz As Pen = New Pen(Color.Black, 1)
        ' Punto inicial
        XAnterior = Xxx(0)
        YAnterior = Yyy(0)
        ' Segmentos que forman el trazado de la función
        For i = 1 To vlong Step 1
            Función.AddLine(Xxx(i - 1), Yyy(i - 1), Xxx(i), Yyy(i))
        Next
        ' Establecer la calidad con la que se dibujará
        g.SmoothingMode = calidad
        ' Dibujar todo aplicando transformaciones locales
        EjeX.Transform(matriz)
        g.DrawPath(lápiz, EjeX)      ' Eje X
        EjeY.Transform(matriz)
        g.DrawPath(lápiz, EjeY)      ' Eje Y
        lápiz.Color = Color.Blue
        Función.Transform(matriz)    ' Función
        g.DrawPath(lápiz, Función)

        ' Si el botón del ratón está pulsado, dibujar el cursor
        If (botonPulsado) Then
            g.DrawLine(Pens.Red, x1, y1, x2, y2)
            g.DrawLine(Pens.Red, x11, y11, x22, y22)
            ' Convertir píxeles a coordenadas lógicas
            Dim x1log As Single = Xmin + x1 * (Xmax - Xmin) / (ciFuncion.Width - 5)
            Dim y1log As Single = Ymax + y11 * (Ymin - Ymax) / (ciFuncion.Height - 5)
            ' Mostrar las coordenadas en las cajas de texto
            ctCoordX.Text = String.Format("{0:F4}", x1log)
            ctCoordY.Text = String.Format("{0:F4}", y1log)
        End If
    End Sub
    Private Sub ciFuncion_SizeChanged(sender As Object, e As EventArgs) Handles ciFuncion.SizeChanged
        ciFuncion.Invalidate()
    End Sub
    Private Sub ciFuncion_MouseMove(sender As Object, e As MouseEventArgs) Handles ciFuncion.MouseMove
        If (e.Button = MouseButtons.Left) Then
            botonPulsado = True
            ' Coordenadas del cursor a dibujar
            x1 = e.X : y1 = 0 : x2 = e.X : y2 = ciFuncion.Height
            y11 = e.Y : x11 = 0 : y22 = e.Y : x22 = ciFuncion.Width
            ciFuncion.Invalidate()
        End If
    End Sub
    Private Sub ciFuncion_MouseUp(sender As Object, e As MouseEventArgs) Handles ciFuncion.MouseUp
        botonPulsado = False
        ciFuncion.Invalidate()
        ' borrar el cursor
        ctCoordX.Text = ""
        ctCoordY.Text = ""
    End Sub

End Class
