﻿Public Class Salto_Hidraulico
    Dim k, b, y, D, S, T, alpha, Q As String
    Dim T1, T2, P, Rh, Kc, V, Fr2, Fr1, Fra, Frb, Es, theta, hs, Dy, eta, A1, A2, H2, H1, Ya, Yb, yc As Double
    Dim g As Single = 9.81
    Dim y1, y2, ecslong, Rg1, Rg2, TS, L As String
    '%***********************************************************************************************
    '%------------------------------------------TAPECIAL-------------------------------------------
    '%***********************************************************************************************
    Private Sub TextBox1_TextChanged(sender As Object, e As EventArgs) Handles TextBox1.TextChanged
        b = Val(TextBox1.Text)
        AcceptButton = Button4
    End Sub
    Private Sub TextBox2_TextChanged(sender As Object, e As EventArgs) Handles TextBox2.TextChanged
        k = Val(TextBox2.Text)
        AcceptButton = Button4
    End Sub
    Private Sub TextBox3_TextChanged(sender As Object, e As EventArgs) Handles TextBox3.TextChanged
        S = Val(TextBox3.Text)
        AcceptButton = Button4
    End Sub
    Private Sub TextBox4_TextChanged(sender As Object, e As EventArgs) Handles TextBox4.TextChanged
        Q = Val(TextBox4.Text)
        AcceptButton = Button4
    End Sub
    Private Sub TextBox5_TextChanged(sender As Object, e As EventArgs) Handles TextBox5.TextChanged
        alpha = Val(TextBox5.Text)
        AcceptButton = Button4
    End Sub
    Private Sub TextBox6_TextChanged(sender As Object, e As EventArgs) Handles TextBox6.TextChanged
        y1 = Val(TextBox6.Text)
        AcceptButton = Button4
    End Sub
    Private Sub ComboBox1_MouseClick(sender As Object, e As MouseEventArgs) Handles ComboBox1.MouseClick
        ComboBox1.Items.Remove("Einwachter(1932)")
        ComboBox1.Items.Remove("Peterka (Lj)")
        ComboBox1.Items.Remove("Silvester (Lj)")
        ComboBox1.Items.Remove("Smetana y Tizon (Lj)")
        ComboBox1.Items.Remove("Wóycicki (Lj)")
        ComboBox1.Items.Remove("Chertusov")
        ComboBox1.Items.Remove("Safranez(1929) (Lr)")
        ComboBox1.Items.Remove("Posey y Hsing (1938) (Lj)")
        ComboBox1.Items.Remove("Silvester (1964) (Lj)")
        If k <> 0 And b <> 0 Then
            ComboBox1.Items.Add("Posey y Hsing (1938) (Lj)")
            ComboBox1.Items.Add("Silvester (1964) (Lj)")
        End If
        If k = 0 Or k = "" Then
            ComboBox1.Items.Add("Einwachter(1932)")
            ComboBox1.Items.Add("Peterka (Lj)")
            ComboBox1.Items.Add("Silvester (Lj)")
            ComboBox1.Items.Add("Smetana y Tizon (Lj)")
            ComboBox1.Items.Add("Wóycicki (Lj)")
            ComboBox1.Items.Add("Chertusov")
            ComboBox1.Items.Add("Safranez(1929) (Lr)")
        End If
    End Sub
    Private Sub Button4_Click_1(sender As Object, e As EventArgs) Handles Button4.Click
        theta = Math.Atan(S)
        Kc = alpha * Q ^ 2 / (g * Math.Cos(theta))
        yc = Trapecial_TC(b, k, k, Kc)
        TextBox8.Text = yc
        '///////////////////////////////////////////////////////// Primer Tirante conjugado 
        T1 = T_byk_trapecio(b, k, k, y1)
        V = Q / A_byk_trapecio(b, k, k, y1)
        Fr1 = Froude(A_byk_trapecio(b, k, k, y1), g, V, alpha, theta, T1)
        Fra = Fr1
        If Fr1 = 1 Then
            Rg1 = "Crítico"
        ElseIf Fr1 > 1 Then
            Rg1 = "Supercrítico"
        Else
            Rg1 = "Subcrítico"
        End If
        '///////////////////////////////////////////////////////// Cálculo del Tirante conjugado
        y2 = Salto_h_Trapecial(Q, y1, k, b, Fr1)
        T2 = T_byk_trapecio(b, k, k, y2)
        V = Q / A_byk_trapecio(b, k, k, y2)
        Fr2 = Froude(A_byk_trapecio(b, k, k, y2), g, V, alpha, theta, T2)
        Frb = Fr2
        If Fr2 = 1 Then
            Rg2 = "Crítico"
        ElseIf Fr2 > 1 Then
            Rg2 = "Supercrítico"
        Else
            Rg2 = "Subcrítico"
        End If
        '///////////////////////////////////////////////////////// Acomodo variables
        If y1 < y2 Then
            Ya = y1
            Yb = y2
            A1 = A_byk_trapecio(b, k, k, y1)
            A2 = A_byk_trapecio(b, k, k, y2)
        Else
            Ya = y1
            Yb = y2
            y1 = Yb
            y2 = Ya
            Fr1 = Fr2
            A1 = A_byk_trapecio(b, k, k, y1)
            A2 = A_byk_trapecio(b, k, k, y2)
            T1 = T_byk_trapecio(b, k, k, y1)
        End If
        '///////////////////////////////////////////////////////// Cálculo de la Perdida de engergía
        hs = y1 - y2 + Fr1 ^ 2 * A1 / (2 * T1) * (1 - (A1 / A2) ^ 2)
        '///////////////////////////////////////////////////////// Cálculo de la Altura del salto
        Dy = y2 - y1
        '///////////////////////////////////////////////////////// Cálculo de la Eficiencia
        H1 = Math.Round(Energia_Esp(A_byk_trapecio(b, k, k, y1), g, y1, Q, alpha, theta), 6)
        H2 = Math.Round(Energia_Esp(A_byk_trapecio(b, k, k, y2), g, y2, Q, alpha, theta), 6)
        eta = hs / H1
        '///////////////////////////////////////////////////////// Cálculo de la Longitud el salto
        ecslong = ComboBox1.Text
        If ComboBox1.Text = "Smetana y Tizon (Lj)" Then
            L = Math.Round(6 * (y2 - y1), 4)
        ElseIf ComboBox1.Text = "Safranez(1929) (Lr)" Then
            If Fr1 > 1.72 And Fr1 < 19.1 Then
                L = Math.Round(6 * y1 * Fr1, 4)
            Else
                L = "Fuera de Rango"
            End If
        ElseIf ComboBox1.Text = "Einwachter(1932)" Then
            If Fr1 > 2.5 And Fr1 < 6.95 Then
                L = Math.Round(8.3 * y1 * (Fr1 ^ 0.5 - 1), 4)
            Else
                L = "Fuera de Rango"
            End If
        ElseIf ComboBox1.Text = "Wóycicki (Lj)" Then
            L = Math.Round((y2 - y1) * (8 - 0.05 * y2 / y1), 4)
        ElseIf ComboBox1.Text = "Chertusov" Then
            L = Math.Round(10.3 * y1 * (Fr1 ^ 0.5 - 1) ^ 0.81, 4)
        ElseIf ComboBox1.Text = "Silvester (Lj)" Then
            L = Math.Round(9.75 * y1 * (Fr1 - 1) ^ 1.01, 4)
        ElseIf ComboBox1.Text = "Peterka (Lj)" Then
            L = Math.Round(y2 * (3.491 + 0.73 * Fr1 - 0.06 * Fr1 ^ 2 + 0.001441 * Fr1 ^ 3), 4)
        ElseIf ComboBox1.Text = "Posey y Hsing (1938) (Lj)" Then
            L = Math.Round(5 * y2 * (1 + 4 * ((2 * y2 / y1 + b / (k * y1)) / (2 + b / (k * y1)) - 1) ^ 0.5), 4)
        ElseIf ComboBox1.Text = "Silvester (1964) (Lj)" Then
            If Fr1 > 4 And Fr1 < 8 And (b / (k * y1)) > 4 Then
                L = Math.Round(7.1 * (y2 - y1) * (1 + 10 / (b / (k * y1))), 4)
            Else
                L = "Fuera de Rango"
            End If
        Else
            L = ""
            ecslong = ""
        End If
        '///////////////////////////////////////////////////////// Tipo de Salto
            If 1 < Fr1 And Fr1 <= 1.7 Then
            PictureBox1.Image = ImageList1.Images(1)
            TS = "a) Ondular"
        ElseIf 1.7 < Fr1 And Fr1 <= 2.5 Then
            PictureBox1.Image = ImageList1.Images(2)
            TS = "b) Débil"
        ElseIf 2.5 < Fr1 And Fr1 <= 4.5 Then
            PictureBox1.Image = ImageList1.Images(3)
            TS = "c) Oscilante"
        ElseIf 4.5 < Fr1 And Fr1 <= 9 Then
            PictureBox1.Image = ImageList1.Images(4)
            TS = "d) Estable"
        ElseIf 9 < Fr1 Then
            PictureBox1.Image = ImageList1.Images(5)
            TS = "e) Fuerte"
        Else
            PictureBox1.Image = ImageList1.Images(0)
        End If
        '///////////////////////////////////////////////////////// Llenado de tabla de resultados
        DataGridView1.Rows.Add(Math.Round(Ya, 4), Fra, Rg1, Math.Round(Yb, 4), Frb, Rg2, L, ecslong, Math.Round(hs, 4), Math.Round(Dy, 4), Math.Round(eta, 4), TS)
    End Sub
    '%***********************************************************************************************
    '%------------------------------------------CIRCULAR -------------------------------------------
    '%***********************************************************************************************
    Private Sub TextBox7_TextChanged(sender As Object, e As EventArgs) Handles TextBox7.TextChanged
        D = Val(TextBox7.Text)
        AcceptButton = Button2
    End Sub
    Private Sub TextBox9_TextChanged(sender As Object, e As EventArgs) Handles TextBox9.TextChanged
        S = Val(TextBox9.Text)
        AcceptButton = Button2
    End Sub
    Private Sub TextBox10_TextChanged(sender As Object, e As EventArgs) Handles TextBox10.TextChanged
        Q = Val(TextBox10.Text)
        AcceptButton = Button2
    End Sub
    Private Sub TextBox11_TextChanged(sender As Object, e As EventArgs) Handles TextBox11.TextChanged
        alpha = Val(TextBox11.Text)
        AcceptButton = Button2
    End Sub
    Private Sub TextBox12_TextChanged(sender As Object, e As EventArgs) Handles TextBox12.TextChanged
        y1 = Val(TextBox12.Text)
        If y1 < 0 Then
            MsgBox("Favor de introducir una valor mayor a cero (positivo)")
        End If
        AcceptButton = Button2
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        theta = Math.Atan(S)
        Kc = alpha * Q ^ 2 / (g * Math.Cos(theta))
        yc = Circular_TC(D, Kc)
        TextBox13.Text = yc
        '///////////////////////////////////////////////////////// Primer Tirante conjugado 
        T1 = T_Dy_Circulo(D, y1)
        V = Q / A_Dy_circulo(D, y1)
        Fr1 = Froude(A_Dy_circulo(D, y1), g, V, alpha, theta, T1)
        Fra = Fr1
        If Fr1 = 1 Then
            Rg1 = "Crítico"
        ElseIf Fr1 > 1 Then
            Rg1 = "Supercrítico"
        Else
            Rg1 = "Subcrítico"
        End If
        '///////////////////////////////////////////////////////// Cálculo del Tirante conjugado
        y2 = Salto_h_Circular(Q, y1, D, Fr1, yc)
        T2 = T_Dy_Circulo(D, y2)
        V = Q / A_Dy_circulo(D, y2)
        Fr2 = Froude(A_Dy_circulo(D, y2), g, V, alpha, theta, T2)
        Frb = Fr2
        If Fr2 = 1 Then
            Rg2 = "Crítico"
        ElseIf Fr2 > 1 Then
            Rg2 = "Supercrítico"
        Else
            Rg2 = "Subcrítico"
        End If
        '///////////////////////////////////////////////////////// Acomodo variables
        If y1 < y2 Then
            Ya = y1
            Yb = y2
        Else
            Ya = y1
            Yb = y2
            y1 = Yb
            y2 = Ya
            Fr1 = Fr2
        End If
        A1 = A_Dy_circulo(D, y1)
        A2 = A_Dy_circulo(D, y2)
        T1 = T_Dy_Circulo(D, y1)
        '///////////////////////////////////////////////////////// Cálculo de la Perdida de engergía
        hs = y1 - y2 + Fr1 ^ 2 * A1 / (2 * T1) * (1 - (A1 / A2) ^ 2)
        '///////////////////////////////////////////////////////// Cálculo de la Altura del salto
        Dy = y2 - y1
        '///////////////////////////////////////////////////////// Cálculo de la Eficiencia
        H1 = Math.Round(Energia_Esp(A_Dy_circulo(D, y1), g, y1, Q, alpha, theta), 6)
        H2 = Math.Round(Energia_Esp(A_Dy_circulo(D, y2), g, y2, Q, alpha, theta), 6)
        eta = hs / H1
        '///////////////////////////////////////////////////////// Tipo de Salto
        If 1 < Fr1 And Fr1 <= 1.7 Then
            PictureBox2.Image = ImageList1.Images(1)
            TS = "a) Ondular"
        ElseIf 1.7 < Fr1 And Fr1 <= 2.5 Then
            PictureBox2.Image = ImageList1.Images(2)
            TS = "b) Débil"
        ElseIf 2.5 < Fr1 And Fr1 <= 4.5 Then
            PictureBox2.Image = ImageList1.Images(3)
            TS = "c) Oscilante"
        ElseIf 4.5 < Fr1 And Fr1 <= 9 Then
            PictureBox2.Image = ImageList1.Images(4)
            TS = "d) Estable"
        ElseIf 9 < Fr1 Then
            PictureBox2.Image = ImageList1.Images(5)
            TS = "e) Fuerte"
        Else
            PictureBox2.Image = ImageList1.Images(0)
        End If
        '///////////////////////////////////////////////////////// Llenado de tabla de resultados
        If Yb > Val(TextBox7.Text) Then
            MsgBox("El tirante conjugado, no se puede presentar debido a que es mayor que el diámetro")
            Yb = ""
            Frb = ""
            Rg2 = ""
            L = ""
            ecslong = ""
            hs = ""
            Dy = ""
            eta = ""
            TS = ""
            'ElseIf Fr2 = 1 Then
            '    Yb = ""
            '    Frb = ""
            '    Rg2 = ""
            '    L = ""
            '    ecslong = ""
            '    hs = ""
            '    Dy = ""
            '    eta = ""
            '    TS = ""
        End If
        DataGridView2.Rows.Add(Math.Round(Ya, 4), Fra, Rg1, Math.Round(Yb, 4), Frb, Rg2, Math.Round(hs, 4), Math.Round(Dy, 4), Math.Round(eta, 4), TS)
        'DataGridView2.Rows.Add(Ya, Fra, Rg1, Yb, Frb, Rg2, hs, Dy, eta, TS)
    End Sub
    '%***********************************************************************************************
    '%------------------------------------------PARABÓLA-------------------------------------------
    '%***********************************************************************************************
    Private Sub TextBox14_TextChanged(sender As Object, e As EventArgs) Handles TextBox14.TextChanged
        T = Val(TextBox14.Text)
        AcceptButton = Button3
    End Sub
    Private Sub TextBox15_TextChanged(sender As Object, e As EventArgs) Handles TextBox15.TextChanged
        y = Val(TextBox15.Text)
        AcceptButton = Button3
    End Sub
    Private Sub TextBox28_Enter(sender As Object, e As EventArgs) Handles TextBox28.Enter
        If LTrim$(TextBox15.Text) <> "" And LTrim$(TextBox14.Text) <> "" Then
            TextBox28.Text = Math.Round(k_Ty_parabola(Val(TextBox14.Text), Val(TextBox15.Text)), 4)
        End If
    End Sub
    Private Sub TextBox28_TextChanged(sender As Object, e As EventArgs) Handles TextBox28.TextChanged
        k = Math.Abs(Val(TextBox28.Text))
        AcceptButton = Button3
    End Sub
    Private Sub TextBox16_TextChanged(sender As Object, e As EventArgs) Handles TextBox16.TextChanged
        S = Val(TextBox16.Text)
        AcceptButton = Button3
    End Sub
    Private Sub TextBox17_TextChanged(sender As Object, e As EventArgs) Handles TextBox17.TextChanged
        Q = Val(TextBox17.Text)
        AcceptButton = Button3
    End Sub
    Private Sub TextBox18_TextChanged(sender As Object, e As EventArgs) Handles TextBox18.TextChanged
        alpha = Val(TextBox18.Text)
        AcceptButton = Button3
    End Sub
    Private Sub TextBox27_TextChanged(sender As Object, e As EventArgs) Handles TextBox27.TextChanged
        y1 = Val(TextBox27.Text)
        AcceptButton = Button3
    End Sub
    Private Sub Button3_Click_1(sender As Object, e As EventArgs) Handles Button3.Click
        If LTrim$(TextBox15.Text) <> "" And LTrim$(TextBox14.Text) <> "" Then
            TextBox28.Text = Math.Round(k_Ty_parabola(Val(TextBox14.Text), Val(TextBox15.Text)), 4)
        End If
        theta = Math.Atan(S)
        Kc = alpha * Q ^ 2 / (g * Math.Cos(theta))
        yc = Parabola_TC(k, Kc)
        TextBox19.Text = yc
        '///////////////////////////////////////////////////////// Primer Tirante conjugado 
        T1 = T
        V = Q / A_yk_parabola(y1, k)
        Fr1 = Froude(A_yk_parabola(y1, k), g, V, alpha, theta, T_yk_parabola(y1, k))
        Fra = Fr1
        If Fr1 = 1 Then
            Rg1 = "Crítico"
        ElseIf Fr1 > 1 Then
            Rg1 = "Supercrítico"
        Else
            Rg1 = "Subcrítico"
        End If
        '///////////////////////////////////////////////////////// Cálculo del Tirante conjugado
        y2 = Salto_h_parabola(Q, y1, k, Fr1, yc)
        ' T2 = (y2 / y1) ^ 0.5 * T1
        V = Q / A_yk_parabola(y2, k)
        Fr2 = Froude(A_yk_parabola(y2, k), g, V, alpha, theta, T_yk_parabola(y2, k))
        Frb = Fr2
        If Fr2 = 1 Then
            Rg2 = "Crítico"
        ElseIf Fr2 > 1 Then
            Rg2 = "Supercrítico"
        Else
            Rg2 = "Subcrítico"
        End If
        '///////////////////////////////////////////////////////// Acomodo variables
        If y1 < y2 Then
            Ya = y1
            Yb = y2
            A1 = A_yk_parabola(y1, k)
            A2 = A_yk_parabola(y2, k)
        Else
            Ya = y1
            Yb = y2
            y1 = Yb
            y2 = Ya
            Fr1 = Fr2
            A1 = A_yk_parabola(y1, k)
            A2 = A_yk_parabola(y2, k)
        End If
        '///////////////////////////////////////////////////////// Cálculo de la Perdida de engergía
        hs = y1 - y2 + Fr1 ^ 2 * A1 / (2 * T_yk_parabola(y1, k)) * (1 - (A1 / A2) ^ 2)
        '///////////////////////////////////////////////////////// Cálculo de la Altura del salto
        Dy = y2 - y1
        '///////////////////////////////////////////////////////// Cálculo de la Eficiencia
        H1 = Math.Round(Energia_Esp(A_yk_parabola(y1, k), g, y1, Q, alpha, theta), 6)
        H2 = Math.Round(Energia_Esp(A_yk_parabola(y2, k), g, y2, Q, alpha, theta), 6)
        eta = hs / H1
        '///////////////////////////////////////////////////////// Cálculo de la Longitud el salto
        L = 11.7 * (Fr1 - 1) ^ 0.832 * y1
        ecslong = "Silvester (Lj)"
        '///////////////////////////////////////////////////////// Tipo de Salto
        If 1 < Fr1 And Fr1 <= 1.7 Then
            PictureBox3.Image = ImageList1.Images(1)
            TS = "a) Ondular"
        ElseIf 1.7 < Fr1 And Fr1 <= 2.5 Then
            PictureBox3.Image = ImageList1.Images(2)
            TS = "b) Débil"
        ElseIf 2.5 < Fr1 And Fr1 <= 4.5 Then
            PictureBox3.Image = ImageList1.Images(3)
            TS = "c) Oscilante"
        ElseIf 4.5 < Fr1 And Fr1 <= 9 Then
            PictureBox3.Image = ImageList1.Images(4)
            TS = "d) Estable"
        ElseIf 9 < Fr1 Then
            PictureBox3.Image = ImageList1.Images(5)
            TS = "e) Fuerte"
        Else
            PictureBox3.Image = ImageList1.Images(0)
        End If
        '///////////////////////////////////////////////////////// Llenado de tabla de resultados
        'If Yb < Ya Then
        '    Yb = ""
        '    Frb = ""
        '    Rg2 = ""
        '    L = ""
        '    ecslong = ""
        '    hs = ""
        '    Dy = "" 
        '    eta = ""
        '    TS = ""
        'End If
        DataGridView3.Rows.Add(Math.Round(Ya, 4), Fra, Rg1, Math.Round(Yb, 4), Frb, Rg2, Math.Round(Val(L), 4), ecslong, Math.Round(hs, 4), Math.Round(Dy, 4), Math.Round(eta, 4), TS)
        'DataGridView3.Rows.Add(Ya, Fra, Rg1, Yb, Frb, Rg2, L, ecslong, hs, Dy, eta, TS)
    End Sub
    '%***********************************************************************************************
    '%------------------------------------------HERRADURA -------------------------------------------
    '%***********************************************************************************************
    Private Sub TextBox20_TextChanged(sender As Object, e As EventArgs) Handles TextBox20.TextChanged
        D = Val(TextBox20.Text)
        AcceptButton = Button5
    End Sub
    Private Sub TextBox21_TextChanged(sender As Object, e As EventArgs) Handles TextBox21.TextChanged
        S = Val(TextBox21.Text)
        AcceptButton = Button5
    End Sub
    Private Sub TextBox22_TextChanged(sender As Object, e As EventArgs) Handles TextBox22.TextChanged
        Q = Val(TextBox22.Text)
        AcceptButton = Button5
    End Sub
    Private Sub TextBox23_TextChanged(sender As Object, e As EventArgs) Handles TextBox23.TextChanged
        alpha = Val(TextBox23.Text)
        AcceptButton = Button5
    End Sub
    Private Sub TextBox24_TextChanged(sender As Object, e As EventArgs) Handles TextBox24.TextChanged
        y1 = Val(TextBox24.Text)
        If y1 < 0 Then
            MsgBox("Favor de introducir una valor mayor a cero (positivo)")
        End If
        AcceptButton = Button5
    End Sub
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        theta = Math.Atan(S)
        Kc = alpha * Q ^ 2 / (g * Math.Cos(theta))
        yc = Herradura_TC(D, Kc)
        TextBox25.Text = yc
        '///////////////////////////////////////////////////////// Primer Tirante conjugado 
        T1 = T_Dy_herradura(D, y1)
        V = Q / A_Dy_herradura(D, y1)
        Fr1 = Froude(A_Dy_herradura(D, y1), g, V, alpha, theta, T1)
        Fra = Fr1
        If Fr1 = 1 Then
            Rg1 = "Crítico"
        ElseIf Fr1 > 1 Then
            Rg1 = "Supercrítico"
        Else
            Rg1 = "Subcrítico"
        End If
        '///////////////////////////////////////////////////////// Cálculo del Tirante conjugado
        y2 = Salto_h_Herradura(Q, y1, D, Fr1, yc)
        T2 = T_Dy_herradura(D, y2)
        V = Q / A_Dy_herradura(D, y2)
        Fr2 = Froude(A_Dy_herradura(D, y2), g, V, alpha, theta, T2)
        Frb = Fr2
        If Fr2 = 1 Then
            Rg2 = "Crítico"
        ElseIf Fr2 > 1 Then
            Rg2 = "Supercrítico"
        Else
            Rg2 = "Subcrítico"
        End If
        '///////////////////////////////////////////////////////// Acomodo variables
        If y1 < y2 Then
            Ya = y1
            Yb = y2
        Else
            Ya = y1
            Yb = y2
            y1 = Yb
            y2 = Ya
            Fr1 = Fr2
        End If
        A1 = A_Dy_herradura(D, y1)
        A2 = A_Dy_herradura(D, y2)
        T1 = T_Dy_herradura(D, y1)
        '///////////////////////////////////////////////////////// Cálculo de la Perdida de engergía
        hs = y1 - y2 + Fr1 ^ 2 * A1 / (2 * T1) * (1 - (A1 / A2) ^ 2)
        '///////////////////////////////////////////////////////// Cálculo de la Altura del salto
        Dy = y2 - y1
        '///////////////////////////////////////////////////////// Cálculo de la Eficiencia
        H1 = Math.Round(Energia_Esp(A_Dy_herradura(D, y1), g, y1, Q, alpha, theta), 6)
        H2 = Math.Round(Energia_Esp(A_Dy_herradura(D, y2), g, y2, Q, alpha, theta), 6)
        eta = hs / H1
        '///////////////////////////////////////////////////////// Tipo de Salto
        If 1 < Fr1 And Fr1 <= 1.7 Then
            PictureBox4.Image = ImageList1.Images(1)
            TS = "a) Ondular"
        ElseIf 1.7 < Fr1 And Fr1 <= 2.5 Then
            PictureBox4.Image = ImageList1.Images(2)
            TS = "b) Débil"
        ElseIf 2.5 < Fr1 And Fr1 <= 4.5 Then
            PictureBox4.Image = ImageList1.Images(3)
            TS = "c) Oscilante"
        ElseIf 4.5 < Fr1 And Fr1 <= 9 Then
            PictureBox4.Image = ImageList1.Images(4)
            TS = "d) Estable"
        ElseIf 9 < Fr1 Then
            PictureBox4.Image = ImageList1.Images(5)
            TS = "e) Fuerte"
        Else
            PictureBox4.Image = ImageList1.Images(0)
        End If
        '///////////////////////////////////////////////////////// Llenado de tabla de resultados
        If Yb > Val(TextBox20.Text) Then
            MsgBox("El tirante conjugado, no se puede presentar debido a que es mayor que el diámetro")
            Yb = ""
            Frb = ""
            Rg2 = ""
            L = ""
            ecslong = ""
            hs = ""
            Dy = ""
            eta = ""
            TS = ""
            'ElseIf Fr2 = 1 Then
            '    Yb = ""
            '    Frb = ""
            '    Rg2 = ""
            '    L = ""
            '    ecslong = ""
            '    hs = ""
            '    Dy = ""
            '    eta = ""
            '    TS = ""
        End If
        DataGridView4.Rows.Add(Math.Round(Ya, 4), Fra, Rg1, Math.Round(Yb, 4), Frb, Rg2, Math.Round(hs, 4), Math.Round(Dy, 4), Math.Round(eta, 4), TS)
        '  DataGridView4.Rows.Add(Ya, Fra, Rg1, Yb, Frb, Rg2, hs, Dy, eta, TS)
    End Sub
    '%***********************************************************************************************
    '%-------------------------------------------AYUDA ---------------------------------------------
    '%***********************************************************************************************
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Static im
        im = im + 1
        If im = 5 Then
            im = 0
        End If
        PictureBox7.Image = ImageList2.Images(im)
    End Sub
    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles Button9.Click
        Coriolis.Show()
    End Sub
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        Coriolis.Show()
    End Sub
    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        Coriolis.Show()
    End Sub
    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click
        Coriolis.Show()
    End Sub
    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click
        Geom.Show()
        Geom.Geome.SelectedTab = Geom.Parabola
        Geom.TabControl1.SelectedTab = Geom.TabPage3
    End Sub
    '%***********************************************************************************************
    '%-------------------------------------------MENU ---------------------------------------------
    '%***********************************************************************************************
    Private Sub AcercaDeToolStripMenuItem_Click_1(sender As Object, e As EventArgs) Handles AcercaDeToolStripMenuItem.Click
        Acerca_de.Show()
    End Sub
    Private Sub CalculadoraToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CalculadoraToolStripMenuItem.Click
        'Ejecutar la Calculadora
        Shell("C:\WINDOWS\system32\calc.exe", AppWinStyle.NormalFocus)
    End Sub
    Private Sub GuradarToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles GuradarToolStripMenuItem.Click
        SaveFileDialog1.ShowDialog()
    End Sub
    Private Sub AbrirToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AbrirToolStripMenuItem.Click
        OpenFileDialog1.ShowDialog()
    End Sub
    Private Sub SaveFileDialog1_FileOk(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles SaveFileDialog1.FileOk
        Dim writer As New IO.StreamWriter(SaveFileDialog1.FileName)
        If Me.TabControl1.SelectedTab Is TabPage1 Then
            writer.Write("*********Salto hidráulico********" & vbNewLine)
            writer.Write("*********Datos_trapecial**********" & vbNewLine)
            writer.Write("Base (b), m                      " & vbNewLine & TextBox1.Text & vbNewLine)
            writer.Write("Talud (K)                        " & vbNewLine & TextBox2.Text & vbNewLine)
            writer.Write("Pendiente (S), m/m               " & vbNewLine & TextBox3.Text & vbNewLine)
            writer.Write("Gasto (Q), m^3/s                 " & vbNewLine & TextBox4.Text & vbNewLine)
            writer.Write("Coeficiente de coriolis (alpha)  " & vbNewLine & TextBox5.Text & vbNewLine)
            writer.Write("Tirante conjugado conocido (y),m " & vbNewLine & TextBox6.Text & vbNewLine)
            writer.Write("**************Resultados**************" & vbNewLine)
            writer.Write("                     " & vbNewLine)
            For Each row In DataGridView1.Rows
                writer.Write("      " & row.Cells(0).Value & "      " & row.Cells(1).Value & "      " & row.Cells(2).Value & "      " & row.Cells(3).Value & _
                             "      " & row.Cells(4).Value & "      " & row.Cells(5).Value & "      " & row.Cells(6).Value & "      " & row.Cells(7).Value & _
                             "      " & row.Cells(8).Value & "      " & row.Cells(9).Value & "      " & row.Cells(10).Value & "      " & row.Cells(11).Value & vbNewLine)
            Next
        ElseIf Me.TabControl1.SelectedTab Is TabPage2 Then
            writer.Write("*********Salto hidráulico********" & vbNewLine)
            writer.Write("*********Datos_circular**********" & vbNewLine)
            writer.Write("Diámetro (D), m                  " & vbNewLine & TextBox7.Text & vbNewLine)
            writer.Write("Pendiente (S), m/m               " & vbNewLine & TextBox9.Text & vbNewLine)
            writer.Write("Gasto (Q), m^3/s                 " & vbNewLine & TextBox10.Text & vbNewLine)
            writer.Write("Coeficiente de coriolis (alpha)  " & vbNewLine & TextBox11.Text & vbNewLine)
            writer.Write("Tirante conjugado conocido (y),m " & vbNewLine & TextBox12.Text & vbNewLine)
            writer.Write("**************Resultados**************" & vbNewLine)
            writer.Write("                     " & vbNewLine)
            For Each row In DataGridView2.Rows
                writer.Write("      " & row.Cells(0).Value & "      " & row.Cells(1).Value & "      " & row.Cells(2).Value & "      " & row.Cells(3).Value & _
                             "      " & row.Cells(4).Value & "      " & row.Cells(5).Value & "      " & row.Cells(6).Value & "      " & row.Cells(7).Value & _
                             "      " & row.Cells(8).Value & "      " & row.Cells(9).Value & "      " & vbNewLine)
            Next
        ElseIf Me.TabControl1.SelectedTab Is TabPage3 Then
            writer.Write("*********Salto hidráulico********" & vbNewLine)
            writer.Write("*********Datos_parábola**********" & vbNewLine)
            writer.Write("Ancho de superficie libre (T), m " & vbNewLine & TextBox14.Text & vbNewLine)
            writer.Write("Tirante (y), m                   " & vbNewLine & TextBox15.Text & vbNewLine)
            writer.Write("Constante parabólica (k)         " & vbNewLine & TextBox28.Text & vbNewLine)
            writer.Write("Pendiente (S), m/m               " & vbNewLine & TextBox16.Text & vbNewLine)
            writer.Write("Gasto (Q), m^3/s                 " & vbNewLine & TextBox17.Text & vbNewLine)
            writer.Write("Coeficiente de coriolis (alpha)  " & vbNewLine & TextBox18.Text & vbNewLine)
            writer.Write("Tirante conjugado conocido (y),m " & vbNewLine & TextBox27.Text & vbNewLine)
            writer.Write("**************Resultados**************" & vbNewLine)
            writer.Write("                     " & vbNewLine)
            For Each row In DataGridView3.Rows
                writer.Write("      " & row.Cells(0).Value & "      " & row.Cells(1).Value & "      " & row.Cells(2).Value & "      " & row.Cells(3).Value & _
                        "      " & row.Cells(4).Value & "      " & row.Cells(5).Value & "      " & row.Cells(6).Value & "      " & row.Cells(7).Value & _
                        "      " & row.Cells(8).Value & "      " & row.Cells(9).Value & "      " & row.Cells(10).Value & "      " & row.Cells(11).Value & vbNewLine)
            Next
        ElseIf Me.TabControl1.SelectedTab Is TabPage4 Then
            writer.Write("*********Salto hidráulico********" & vbNewLine)
            writer.Write("*********Datos_herradura*********" & vbNewLine)
            writer.Write("Diámetro (D), m                  " & vbNewLine & TextBox20.Text & vbNewLine)
            writer.Write("Pendiente (S), m/m               " & vbNewLine & TextBox21.Text & vbNewLine)
            writer.Write("Gasto (Q), m^3/s                 " & vbNewLine & TextBox22.Text & vbNewLine)
            writer.Write("Coeficiente de coriolis (alpha)  " & vbNewLine & TextBox23.Text & vbNewLine)
            writer.Write("Tirante conjugado conocido (y),m " & vbNewLine & TextBox24.Text & vbNewLine)
            writer.Write("**************Resultados**************" & vbNewLine)
            writer.Write("                     " & vbNewLine)
            For Each row In DataGridView4.Rows
                writer.Write("      " & row.Cells(0).Value & "      " & row.Cells(1).Value & "      " & row.Cells(2).Value & "      " & row.Cells(3).Value & _
                             "      " & row.Cells(4).Value & "      " & row.Cells(5).Value & "      " & row.Cells(6).Value & "      " & row.Cells(7).Value & _
                             "      " & row.Cells(8).Value & "      " & row.Cells(9).Value & "      " & vbNewLine)
            Next
        End If
        writer.Close()
    End Sub
    Private Sub OpenFileDialog1_FileOk(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk
        Dim reader As New IO.StreamReader(OpenFileDialog1.FileName)
        If Me.TabControl1.SelectedTab Is TabPage1 Then
            reader.ReadLine()
            reader.ReadLine()
            reader.ReadLine()
            TextBox1.Text = reader.ReadLine
            reader.ReadLine()
            TextBox2.Text = reader.ReadLine
            reader.ReadLine()
            TextBox3.Text = reader.ReadLine
            reader.ReadLine()
            TextBox4.Text = reader.ReadLine
            reader.ReadLine()
            TextBox5.Text = reader.ReadLine
            reader.ReadLine()
            TextBox6.Text = reader.ReadLine
        ElseIf Me.TabControl1.SelectedTab Is TabPage2 Then
            reader.ReadLine()
            reader.ReadLine()
            reader.ReadLine()
            TextBox7.Text = reader.ReadLine
            reader.ReadLine()
            TextBox9.Text = reader.ReadLine
            reader.ReadLine()
            TextBox10.Text = reader.ReadLine
            reader.ReadLine()
            TextBox11.Text = reader.ReadLine
            reader.ReadLine()
            TextBox12.Text = reader.ReadLine
        ElseIf Me.TabControl1.SelectedTab Is TabPage3 Then
            reader.ReadLine()
            reader.ReadLine()
            reader.ReadLine()
            TextBox14.Text = reader.ReadLine
            reader.ReadLine()
            TextBox15.Text = reader.ReadLine
            reader.ReadLine()
            TextBox28.Text = reader.ReadLine
            reader.ReadLine()
            TextBox16.Text = reader.ReadLine
            reader.ReadLine()
            TextBox17.Text = reader.ReadLine
            reader.ReadLine()
            TextBox18.Text = reader.ReadLine
            reader.ReadLine()
            TextBox27.Text = reader.ReadLine
        ElseIf Me.TabControl1.SelectedTab Is TabPage4 Then
            reader.ReadLine()
            reader.ReadLine()
            reader.ReadLine()
            TextBox20.Text = reader.ReadLine
            reader.ReadLine()
            TextBox21.Text = reader.ReadLine
            reader.ReadLine()
            TextBox22.Text = reader.ReadLine
            reader.ReadLine()
            TextBox23.Text = reader.ReadLine
            reader.ReadLine()
            TextBox24.Text = reader.ReadLine
        End If
        reader.Close()
    End Sub
    Private Sub CopiarToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CopiarToolStripMenuItem.Click
        If Me.TabControl1.SelectedTab Is TabPage1 Then
            DataGridView1.SelectAll()
            Clipboard.SetDataObject(Me.DataGridView1.GetClipboardContent())
        ElseIf Me.TabControl1.SelectedTab Is TabPage2 Then
            DataGridView2.SelectAll()
            Clipboard.SetDataObject(Me.DataGridView2.GetClipboardContent())
        ElseIf Me.TabControl1.SelectedTab Is TabPage3 Then
            DataGridView3.SelectAll()
            Clipboard.SetDataObject(Me.DataGridView3.GetClipboardContent())
        ElseIf Me.TabControl1.SelectedTab Is TabPage4 Then
            DataGridView4.SelectAll()
            Clipboard.SetDataObject(Me.DataGridView4.GetClipboardContent())
        End If
    End Sub
    '%***********************************************************************************************
    '%-----------------------------------------  Bolqueo de teclas  --------------------------------
    '%Asc(46)= ".", Asc (13)= "enter", Asc(8)= "retroceso", Asc(3)= "ctrl+c (copiar)", Asc(22)="ctrl+v (pegar)", Asc (45)= "-", isnumber= numericos
    '%***********************************************************************************************
    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox2_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox2.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox3_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox3.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 45 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox4_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox4.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox5_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox5.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox6_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox6.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox7_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox7.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox9_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox9.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 45 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox10_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox10.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox11_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox11.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox12_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox12.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox14_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox14.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox15_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox15.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox16_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox16.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 45 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox17_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox17.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox18_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox18.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox20_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox20.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox21_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox21.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 45 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox22_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox22.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox23_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox23.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox24_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox24.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox27_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox27.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox28_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox28.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub


End Class