﻿Module Herradura_Salto_Hidraulico
    Public Function Salto_h_Herradura(Q As Double, y As Double, D As Double, Fr1 As Double, yc As Double) As Double
        Dim Ysh As Double
        Dim g As Double = 9.81
        Dim A2, A1, KG1, KG2, KG As Double
        Dim Sh1 As Double
        Dim tol, y1, y2, fa, fb, fp, i, M, A As Double  'Auxiliares para bsección
        'Datos del tirante conjugado dado
        A1 = A_Dy_herradura(D, y)
        KG1 = KG_Herradura(y, D)
        Sh1 = Q ^ 2 / (g * A1) + A1 * KG1 * y

        'Metodo de Biscecion 
        tol = 0.000000000001
        i = 1
        M = 5000
        If y > yc Then
            y1 = 0
            y2 = yc - 0.00001
        Else
            y1 = yc + 0.00001
            y2 = D '* 0.94
        End If
        Ysh = (y1 + y2) / 2

        A1 = A_Dy_herradura(D, y1)
        A2 = A_Dy_herradura(D, y2)
        A = A_Dy_herradura(D, Ysh)

        KG1 = KG_Herradura(y1, D)
        KG2 = KG_Herradura(y2, D)
        KG = KG_Herradura(Ysh, D)

        fa = Q ^ 2 / (A1 * g) + A1 * KG1 * y1 - Sh1
        fb = Q ^ 2 / (A2 * g) + A2 * KG2 * y2 - Sh1
        fp = Q ^ 2 / (A * g) + A * KG * Ysh - Sh1

        If fa * fb > 0 Then 'No hay solución
        Else
            While Math.Abs(fp) >= tol And i < M
                i = i + 1
                If fb * fp > 0 Then
                    y2 = Ysh
                Else
                    y1 = Ysh
                End If
                Ysh = (y1 + y2) / 2

                A2 = A_Dy_herradura(D, y2)
                A = A_Dy_herradura(D, Ysh)

                KG2 = KG_Herradura(y2, D)
                KG = KG_Herradura(Ysh, D)

                fb = Q ^ 2 / (A2 * g) + A2 * KG2 * y2 - Sh1
                fp = Q ^ 2 / (A * g) + A * KG * Ysh - Sh1
            End While
        End If
        Salto_h_Herradura = Ysh
    End Function
End Module
