﻿Module TN_Herradura
    Public Function Herradura_TN(ByVal D As Double, Kn As Double) As Double
        Dim y, y1, y2, tol, fb, fa, i, M, fp, A2, A, A1, P, P2, P1 As Double
        'Metodo de Biscecion 
        tol = 0.0000000000001
        y1 = 0.00001
        y2 = D * 0.938181216161
        y = (y1 + y2) / 2

        A1 = A_Dy_herradura(D, y1)
        A2 = A_Dy_herradura(D, y2)
        A = A_Dy_herradura(D, y)

        P1 = P_Dy_herradura(D, y1)
        P2 = P_Dy_herradura(D, y2)
        P = P_Dy_herradura(D, y)

        fa = (A1) ^ (5 / 3) / (P1) ^ (2 / 3) - Kn
        fb = (A2) ^ (5 / 3) / (P2) ^ (2 / 3) - Kn
        fp = (A) ^ (5 / 3) / (P) ^ (2 / 3) - Kn

        If fa * fb > 0 Then 'no hay solucion
            MsgBox("Disminur el gasto o aumentar el diámetro")
            y = -2
        Else
            i = 1
            M = 1000
            While Math.Abs(fp) >= tol And i < M
                i = i + 1
                If fb * fp > 0 Then
                    y2 = y
                Else
                    y1 = y
                End If
                y = (y1 + y2) / 2

                A2 = A_Dy_herradura(D, y2)
                A = A_Dy_herradura(D, y)

                P2 = P_Dy_herradura(D, y2)
                P = P_Dy_herradura(D, y)

                fb = (A2) ^ (5 / 3) / (P2) ^ (2 / 3) - Kn
                fp = (A) ^ (5 / 3) / (P) ^ (2 / 3) - Kn
            End While
        End If
        Herradura_TN = y
    End Function
End Module
