﻿Module No_Froude
    Public Function Froude(A As Double, g As Double, V As Double, alpha As Double, theta As Double, T As Double) As Double
        Dim F As Double
        F = Math.Round(V / ((g * Math.Cos(theta) / alpha) * (A / T)) ^ (1 / 2), 3)
        Froude = F
    End Function
End Module
