﻿Module Compuerta_cd
    Public Function cd_compuerta(y1 As Double, y3 As Double, a As Double) As Double
        '% ISO 13550, 2002
        '% a, apertura de la compuerta
        '% r, radio del borde de la compuerta (r=0 para comp. plana)
        '% y1,tirante aguas arriba de la compuerta
        '% y3, tirante aguas abajo de la compuerta
        '% Q, gasto
        '% =====================    ISO 13550, 2002   ============================
        Dim r, Cc, CD1, cd, alpha, beta, aux1, cdr As Double
        r = 0
        If r / a > 2.35 Then
            Cc = 0.99
        Else
            Cc = 0.51 + 0.1 * (23.04 - (2 * r / a - 4.69) ^ 2) ^ 0.5
        End If
        '%  Descarga libre
        CD1 = Cc / (1 + (Cc * a) / y1) ^ 0.5
        If y3 / a < (Cc / 2) * ((1 + 16 * (y1 / (a * Cc) - 1)) ^ 0.5 - 1) Then
            cd = CD1
            Compuertas_y_orificios.PictureBox1.Image = Compuertas_y_orificios.ImageList1.Images(0)
            Compuertas_y_orificios.Label13.Text = "Tipo de descarga: Libre"
        Else
            '% Descarga sumergida
            alpha = a * Cc / y1
            beta = a * Cc / y3
            aux1 = 2 * alpha * (1 - beta) / (1 - alpha ^ 2)
            Cdr = ((1 - aux1 - ((aux1 - 1) ^ 2 + alpha ^ 2 / beta ^ 2 - 1) ^ 0.5) / (1 - alpha)) ^ 0.5
            cd = CD1 * cdr
            Compuertas_y_orificios.PictureBox1.Image = Compuertas_y_orificios.ImageList1.Images(1)
            Compuertas_y_orificios.Label13.Text = "Tipo de descarga: Ahogada"
        End If
        Compuertas_y_orificios.TextBox7.Text = Math.Round(Cc, 4)
        Compuertas_y_orificios.TextBox8.Text = Math.Round(cd / Cc, 4)
        cd_compuerta = cd
    End Function
End Module
