﻿Module FEV_Fdy
    Public Function FEV_DF(b As Double, k As Double, y As Double, dy As Double, dx As Double, qx As Double, Q1 As Double, n As Double, S As Double) As Double
        Dim g = 9.81              'gravedad
        Dim A1, A2, P1, P2, vm, Av, Qm, Sm, Fdy, sm1, sm2 As Double
        A1 = A_byk_trapecio(b, k, k, y)
        A2 = A_byk_trapecio(b, k, k, y + dy)
        P1 = P_byk_trapecio(b, k, k, y)
        P2 = P_byk_trapecio(b, k, k, y + dy)

        vm = Q1 / 2 * (A1 + A2) / (A1 * A2) + qx * dx / (2 * A2)
        Av = Q1 * (A1 - A2) / (A1 * A2) + qx * dx / A2
        Qm = Q1 + qx * dx / 2
        sm1 = n ^ 2 * Q1 ^ 2 * P1 ^ (4 / 3) / A1 ^ (10 / 3)
        sm2 = n ^ 2 * (Q1 + dx * qx) ^ 2 * P2 ^ (4 / 3) / Math.Abs(A2) ^ (10 / 3)
        Sm = (sm1 + sm2) / 2
        Fdy = dy + vm / g * (Av + vm * qx * dx / Qm) + (Sm - S) * dx
        FEV_DF = Fdy
    End Function
End Module
