﻿Imports System.Math
Imports System.Drawing.Drawing2D
Module Graficar
    Public Function Graf_perfil(ByRef X() As Double, ByRef Y() As Double, S As Double, dibujo As Graphics, xce As Integer, yce As Integer)
        Dim xmin, xmax, ymin, ymax, Longitud, plantilla, Tirante, vlong As Double
        vlong = X.Length - 1
        If X(0) > X(vlong) Then
            xmax = X(0)
            xmin = X(vlong)
        Else
            xmax = X(vlong)
            xmin = X(0)
        End If
        If Y(0) > Y(vlong) Then
            ymax = Y(0)
            ymin = Y(vlong)
        Else
            ymax = Y(vlong)
            ymin = Y(0)
        End If
        Longitud = Math.Abs(xmax - xmin)
        Tirante = Math.Abs(ymax - ymin)
        '%***********************************************************************************************
        '%-----------------------------------------Graficación -------------------------------------
        '%***********************************************************************************************
        Dim pincel = New Pen(Color.Blue, 2)
        Dim plant = New Pen(Color.Black, 1)
        Dim fsy, fsx As Integer
        Dim Xp(vlong) As Integer
        Dim Yp(vlong) As Integer
        Dim tipoletra As Font = New Font("Courier New", 8)
        Dim XpS As Integer
        Dim pasox As Integer

        dibujo.SmoothingMode = SmoothingMode.HighQuality
        'Escalar a pixeles
        plantilla = -X(vlong) * S
        If X(vlong) > 0 Then
            dibujo.TranslateTransform(0, 2 * yce / 3)
            '  dibujo.TranslateTransform(xce, yce / 2)
        ElseIf X(vlong) < 0 Then
            dibujo.TranslateTransform(xce, 2 * yce / 3)
            ' dibujo.TranslateTransform(xce, yce / 2)
        End If
        fsy = -Math.Abs(yce - 2 * yce / 3 - 30) / Math.Abs(ymax - plantilla)
        ' fsy = -Math.Abs(yce - yce / 2 - 30) / Math.Abs(ymax - plantilla)
        fsx = Math.Abs(xce - 20) / Longitud
        pasox = fsx * Longitud / 10
        If fsx <> 0 Then
            'Dibujar el perfil
            Xp(0) = fsx * X(0)
            Yp(0) = fsy * Y(0)
            For i = 1 To vlong Step 1
                Xp(i) = fsx * X(i)
                Yp(i) = fsy * Y(i)
                dibujo.DrawLine(pincel, Xp(i - 1), Yp(i - 1), Xp(i), Yp(i))
            Next
        ElseIf fsx = 0 Then
            fsx = Longitud / Math.Abs(xce - 20)
            pasox = Longitud / 10 / fsy
            'Dibujar el perfil
            Xp(0) = X(0) / fsx
            Yp(0) = fsy * Y(0)
            For i = 1 To vlong Step 1
                Xp(i) = X(i) / fsx
                Yp(i) = fsy * Y(i)
                dibujo.DrawLine(pincel, Xp(i - 1), Yp(i - 1), Xp(i), Yp(i))
            Next
        End If

        XpS = plantilla * fsy
        dibujo.DrawLine(plant, Xp(0), 0, Xp(vlong), XpS)

        ''Ejes
        'Dim numero As String
        'Dim base As Integer
        'Dim base2 As Integer
        'Dim pasoy1 As Double
        'Dim pasoy As Integer
        'If X(vlong) > 0 Then
        '    base = yce / 3 - 3
        '    numero = 0
        '    For cc = 0 To xce Step pasox
        '        dibujo.DrawLine(Pens.Blue, cc, base, cc, base - 5) 'x
        '        dibujo.DrawString(numero, tipoletra, Brushes.Black, (cc - 5), base - 18)
        '        numero = Math.Round(numero + Longitud / 10, 1)
        '    Next
        'ElseIf X(vlong) < 0 Then
        '    base = yce / 3 - 3
        '    numero = 0
        '    For cc = 0 To -xce Step pasox
        '        dibujo.DrawLine(Pens.Blue, cc, base, cc, base - 5) 'x
        '        dibujo.DrawString(numero, tipoletra, Brushes.Black, (cc - 5), base - 18)
        '        numero = Math.Round(numero - Longitud / 10, 1)
        '    Next
        'End If

        'pasoy1 = -fsy * Tirante / 10
        'pasoy = pasoy1
        'base2 = 2 * yce / 3
        'numero = 0
        'For cc = base To -base2 Step pasoy
        '    dibujo.DrawLine(Pens.Blue, 0, cc, 5, cc)  'y
        '    dibujo.DrawString(numero, tipoletra, Brushes.Black, 5, (cc - 5))
        '    numero = Math.Round(numero + Tirante / 10, 1)
        'Next


        


        Graf_perfil = dibujo
    End Function

End Module
