﻿Module FGV_dy_parabola_Rk
    Public Function FGV_dy_parabola(Q As Double, S As Double, n As Double, k As Double, yf As Double, y1 As Double, Li As Double, h As Double, alpha As Double, theta As Double, dibujo As Graphics, xce As Integer, yce As Integer) As Double()
        Dim A, P, T, R, U, Fr, Sf, dydx, K1, k2, k3, k4, y2, y3, y4 As Double
        Dim g As Double = 9.81
        Dim i As Integer = 0
        Dim fallo As Integer = 0
        Dim xx As Double = 0
        Dim Y() As Double
        Dim X() As Double
        Dim Ys() As Double
        Dim Xs() As Double
        '% ***********flujo gradualmente varido por Runge-Kutta dy**********
        While Math.Abs(y1 - yf) > Math.Abs(h) And Math.Abs(y1 - yf) > Math.Abs(0.00001)
            ' %*********Cálculo de k1
            A = A_yk_parabola(y1, k)
            P = P_yk_parabola(y1, k)
            T = T_yk_parabola(y1, k)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (1 - Fr ^ 2) / (S - Sf)
            K1 = h * dydx
            ' %*********Cálculo de k2
            y2 = y1 + 0.5 * h
            A = A_yk_parabola(y2, k)
            P = P_yk_parabola(y2, k)
            T = T_yk_parabola(y2, k)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (1 - Fr ^ 2) / (S - Sf)
            k2 = h * dydx
            ' %*********Cálculo de k3
            y3 = y1 + 0.5 * h
            A = A_yk_parabola(y3, k)
            P = P_yk_parabola(y3, k)
            T = T_yk_parabola(y3, k)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (1 - Fr ^ 2) / (S - Sf)
            k3 = h * dydx
            ' %*********Cálculo de k4
            y4 = y1 + h
            A = A_yk_parabola(y4, k)
            P = P_yk_parabola(y4, k)
            T = T_yk_parabola(y4, k)
            R = A / P
            U = Q / A
            Fr = Froude(A, g, U, alpha, theta, T)
            Sf = (n * U / R ^ (2 / 3)) ^ 2
            dydx = (1 - Fr ^ 2) / (S - Sf)
            k4 = h * dydx
            '%almacenamiento del tirante y distancia en vectores
            ReDim Preserve X(i)
            ReDim Preserve Y(i)
            ReDim Preserve Xs(i)
            ReDim Preserve Ys(i)
            Y(i) = y1
            X(i) = Li
            Xs(i) = xx
            Ys(i) = Y(i) - xx * (S)
            xx = xx + (1 / 6 * (K1 + 2 * k2 + 2 * k3 + k4))
            Li = Li + 1 / 6 * (K1 + 2 * k2 + 2 * k3 + k4)
            y1 = y4
            FGV.DataGridView3.Rows.Add(Math.Round(X(i), 4), Math.Round(Y(i), 4))
            i = i + 1
        End While
        ReDim Preserve X(i)
        ReDim Preserve Y(i)
        Y(i) = y1
        X(i) = Li
        FGV.DataGridView1.Rows.Add(Math.Round(X(i), 4), Math.Round(Y(i), 4))
        FGV_dy_parabola = Y
        'Llamar a la gráfica
        ReDim Preserve Xs(i - 1)
        ReDim Preserve Ys(i - 1)
        Graf_perfil(Xs, Ys, S, dibujo, xce, yce)
    End Function

End Module
