﻿Module Herradura_Centro_Gravedad
    Public Function KG_Herradura(y As Double, D As Double) As Double
        Dim KG As Double
        Dim g As Double = 9.81
        Dim m, Po As Double
        Po = 0.08856217 * D
        If y <= Po Then
            m = A_Dy_herradura(D, y) / D ^ 2
            KG = 1 - D / y + (2 * (1 - y / (2 * D)) ^ (3 / 2) * (y / (2 * D)) ^ 0.5) / (3 / 4 * m)
        ElseIf y > Po And y <= 0.5 * D Then
            m = A_Dy_herradura(D, y) / D ^ 2
            KG = 1 / (m * y / D) * (0.9366240398 * y / D - 0.5 * (y / D) ^ 2 - 0.9107993196 + 1 / 3 * (2.25 + (y / D) ^ 2 - y / D) * (0.75 + y / D - (y / D) ^ 2) ^ 0.5 + (0.5 - y / D) * Math.Asin(0.5 - y / D))
        Else
            m = A_Dy_herradura(D, y) / D ^ 2
            KG = 1 / (m * y / D) * (1 / 4 * (y / D - 0.5) * Math.Acos(1 - 2 * y / D) + (y / D - 0.5) ^ 2 * (y / D - (y / D) ^ 2) ^ 0.5 + 2 / 3 * (y / D - (y / D) ^ 2) ^ (3 / 2) - 0.00611445 + 0.043924958 * (y / D))
        End If
        KG_Herradura = KG
    End Function

End Module
