﻿Module Parabola_Salto_Hidraulico
    Public Function Salto_h_parabola(Q As Double, y As Double, K As Double, Fr1 As Double, yc As Double) As Double
        Dim Ysh As Double
        Dim g As Double = 9.81
        Dim tol, y1, y2, fa, fb, fp, i, M, A1, A2, A, Sh1, KG As Double

        A1 = A_yk_parabola(y, K)
        KG = 2 / 5
        Sh1 = Q ^ 2 / (g * A1) + A1 * KG * y

        'Metodo de Biscecion 
        tol = 0.000000000001
        i = 1
        M = 5000
        If y > yc Then
            y1 = 0
            y2 = yc - 0.00001
        Else
            y1 = yc + 0.00001
            y2 = 100
        End If
        Ysh = (y1 + y2) / 2

        A1 = A_yk_parabola(y1, K)
        A2 = A_yk_parabola(y2, K)
        A = A_yk_parabola(Ysh, K)

        fa = Q ^ 2 / (A1 * g) + A1 * KG * y1 - Sh1
        fb = Q ^ 2 / (A2 * g) + A2 * KG * y2 - Sh1
        fp = Q ^ 2 / (A * g) + A * KG * Ysh - Sh1

        If fa * fb > 0 Then 'No hay solución
        Else
            While Math.Abs(fp) >= tol And i < M
                i = i + 1
                If fb * fp > 0 Then
                    y2 = Ysh
                Else
                    y1 = Ysh
                End If
                Ysh = (y1 + y2) / 2

                A2 = A_yk_parabola(y2, K)
                A = A_yk_parabola(Ysh, K)

                fb = Q ^ 2 / (A2 * g) + A2 * KG * y2 - Sh1
                fp = Q ^ 2 / (A * g) + A * KG * Ysh - Sh1
            End While
        End If
        Salto_h_parabola = Ysh
    End Function
End Module
