﻿Public Class Vertedores
    Dim b, Br, h, w, theta, D, a As Double
    Dim mu, Q, co, c, phi As Double
    Dim g As Double = 9.81
    '%***********************************************************************************************
    '%-------------------------------------  Rectangular  ------------------------------------------
    '%***********************************************************************************************
    Private Sub TextBox1_TextChanged(sender As Object, e As EventArgs) Handles TextBox1.TextChanged
        b = Val(TextBox1.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox2_TextChanged(sender As Object, e As EventArgs) Handles TextBox2.TextChanged
        Br = Val(TextBox2.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox3_TextChanged(sender As Object, e As EventArgs) Handles TextBox3.TextChanged
        h = Val(TextBox3.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox4_TextChanged(sender As Object, e As EventArgs) Handles TextBox4.TextChanged
        w = Val(TextBox4.Text)
        AcceptButton = Button1
    End Sub
    Private Sub TextBox5_TextChanged(sender As Object, e As EventArgs) Handles TextBox5.TextChanged
        theta = Val(TextBox5.Text)
        AcceptButton = Button1
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        co = 1.1951 - 0.3902 * theta / 180
        If 0.1 <= h And h <= 0.6 And 0.5 <= b And b <= 2.0 And 0.2 <= w And w <= 1.13 Then
            mu = (0.6075 - 0.045 * (Br - b) / Br + 0.0041 / h) * (1 + 0.55 * (b / Br) ^ 2 * (h / (h + w)) ^ 2)
        ElseIf 0.025 <= h And h <= 0.8 And b <= 0.3 * Br And 0.3 <= w Then
            mu = (0.578 + 0.037 * (b / Br) ^ 2 + (3.615 - 3 * (b / Br) ^ 2) / (1000 * h + 1.6)) * (1 + 0.5 * (b / Br) ^ 4 * (h / (h + w)) ^ 2)
        ElseIf 0.075 <= h And h <= 0.6 And 0.3 <= b And 0.3 <= w Then
            mu = 0.616 * (1 - b / (10 * Br))
        ElseIf 0.1 <= h And h <= 0.8 And 0.3 <= b And 0.6 <= w Then
            mu = (0.60358 + 0.0813 * (h + 0.011) / w) * (1 + 0.0011 / h) ^ (3 / 2)
        Else
            MsgBox("Fuera de rango de las ecuaciones experimentales.")
            Exit Sub
        End If
        If Br < b Then
            MsgBox("La base del canal (B), no puede ser menor que la base del vertedor (b).")
            Exit Sub
        End If
        mu = mu * co
        Q = 2 / 3 * Math.Sqrt(2 * g) * mu * b * h ^ (3 / 2)
        TextBox6.Text = Math.Round(mu, 4)
        TextBox7.Text = Math.Round(Q, 6)


    End Sub
    '%***********************************************************************************************
    '%------------------------------------- Triangular  ------------------------------------------
    '%***********************************************************************************************
    Private Sub TextBox8_TextChanged(sender As Object, e As EventArgs) Handles TextBox8.TextChanged
        h = Val(TextBox8.Text)
        AcceptButton = Button2
    End Sub
    Private Sub TextBox9_TextChanged(sender As Object, e As EventArgs) Handles TextBox9.TextChanged
        w = Val(TextBox9.Text)
        AcceptButton = Button2
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox1.SelectedIndexChanged
        If ComboBox1.Text = "90" Then
            theta = 90
        ElseIf ComboBox1.Text = "60" Then
            theta = 60
        ElseIf ComboBox1.Text = "45" Then
            theta = 45
        End If
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        c = 1.32 * Math.Tan(theta / 2) / h ^ 0.03
        Q = Math.Abs(c) * h ^ (5 / 2)
        TextBox10.Text = Math.Round(c, 4)
        TextBox11.Text = Math.Round(Q, 6)
    End Sub
    '%***********************************************************************************************
    '%------------------------------------- Trapecial  ------------------------------------------
    '%***********************************************************************************************
    Private Sub TextBox12_TextChanged(sender As Object, e As EventArgs) Handles TextBox12.TextChanged
        b = Val(TextBox12.Text)
        AcceptButton = Button3
    End Sub
    Private Sub TextBox13_TextChanged(sender As Object, e As EventArgs) Handles TextBox13.TextChanged
        Br = Val(TextBox13.Text)
        AcceptButton = Button3
    End Sub
    Private Sub TextBox14_TextChanged(sender As Object, e As EventArgs) Handles TextBox14.TextChanged
        h = Val(TextBox14.Text)
        AcceptButton = Button3
    End Sub
    Private Sub TextBox15_TextChanged(sender As Object, e As EventArgs) Handles TextBox15.TextChanged
        w = Val(TextBox15.Text)
        AcceptButton = Button3
    End Sub
    Private Sub ComboBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox2.SelectedIndexChanged
        If ComboBox1.Text = "90" Then
            theta = 90
        ElseIf ComboBox1.Text = "60" Then
            theta = 60
        ElseIf ComboBox1.Text = "45" Then
            theta = 45
        End If
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        If 0.1 <= h And h <= 0.6 And 0.5 <= b And b <= 2.0 And 0.2 <= w And w <= 1.13 Then
            mu = (0.6075 - 0.045 * (Br - b) / Br + 0.0041 / h) * (1 + 0.55 * (b / Br) ^ 2 * (h / (h + w)) ^ 2)
        ElseIf 0.025 <= h And h <= 0.8 And b <= 0.3 * Br And 0.3 <= w Then
            mu = (0.578 + 0.037 * (b / Br) ^ 2 + (3.615 - 3 * (b / Br) ^ 2) / (1000 * h + 1.6)) * (1 + 0.5 * (b / Br) ^ 4 * (h / (h + w)) ^ 2)
        ElseIf 0.075 <= h And h <= 0.6 And 0.3 <= b And 0.3 <= w Then
            mu = 0.616 * (1 - b / (10 * Br))
        ElseIf 0.1 <= h And h <= 0.8 And 0.3 <= b And 0.6 <= w Then
            mu = (0.60358 + 0.0813 * (h + 0.011) / w) * (1 + 0.0011 / h) ^ (3 / 2)
        Else
            MsgBox("Fuera de rango de las ecuaciones experimentales.")
            mu = -999999
        End If
        If mu = -999999 Then
            TextBox16.Text = ""
            TextBox17.Text = ""
            TextBox18.Text = ""
        Else
            c = 1.32 * Math.Tan(theta / 2) / h ^ 0.03
            Q = 2 / 3 * Math.Sqrt(2 * g) * mu * b * h ^ (3 / 2) + Math.Abs(c) * h ^ (5 / 2)
            TextBox16.Text = Math.Round(mu, 4)
            TextBox17.Text = Math.Round(c, 6)
            TextBox18.Text = Math.Round(Q, 6)
        End If
    End Sub
    '%***********************************************************************************************
    '%-------------------------------------  Circular ------------------------------------------
    '%***********************************************************************************************
    Private Sub TextBox19_TextChanged(sender As Object, e As EventArgs) Handles TextBox19.TextChanged
        D = Val(TextBox19.Text)
        AcceptButton = Button4
    End Sub
    Private Sub TextBox20_TextChanged(sender As Object, e As EventArgs) Handles TextBox20.TextChanged
        h = Val(TextBox20.Text)
        AcceptButton = Button4
    End Sub
    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        mu = 0.555 + D / (110 * h) + 0.041 * h / D
        phi = 10.12 * (h / D) ^ 1.975 - 2.66 * (h / D) ^ 3.78
        Q = phi * mu * D ^ (5 / 2)
        TextBox21.Text = Math.Round(phi, 6)
        TextBox22.Text = Math.Round(mu, 6)
        TextBox23.Text = Math.Round(Q, 6)
    End Sub
    '%***********************************************************************************************
    '%-------------------------------------  Proporcional  ------------------------------------------
    '%***********************************************************************************************
    Private Sub TextBox24_TextChanged(sender As Object, e As EventArgs) Handles TextBox24.TextChanged
        a = Val(TextBox24.Text)
        AcceptButton = Button5
    End Sub
    Private Sub TextBox25_TextChanged(sender As Object, e As EventArgs) Handles TextBox25.TextChanged
        h = Val(TextBox25.Text)
        AcceptButton = Button5
    End Sub
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        If h >= 0.061 And h <= 0.244 Then
            mu = -9.545586 * h ^ 3 + 5.778017 * h ^ 2 - 1.26776 * h + 0.714
        ElseIf h > 0.244 And h <= 0.61 Then
            mu = 0.000141 * h ^ 2 + 0.006428 * h + 0.604026
        ElseIf h > 0.061 And h <= 0.915 Then
            mu = 0.006452 * h + 0.605097
        Else
            MsgBox("Fuera de rango.")
            mu = -999999
        End If
        If mu = -999999 Then
            TextBox26.Text = ""
            TextBox27.Text = ""
        Else
            Q = Math.PI * Math.Sqrt(2 * 9.81) * mu * a ^ 0.5 * h
            TextBox26.Text = Math.Round(mu, 6)
            TextBox27.Text = Math.Round(Q, 6)
        End If
    End Sub
    '%***********************************************************************************************
    '%-------------------------------------------MENU ---------------------------------------------
    '%***********************************************************************************************
    Private Sub AcercaDeToolStripMenuItem_Click_1(sender As Object, e As EventArgs) Handles AcercaDeToolStripMenuItem.Click
        Acerca_de.Show()
    End Sub
    Private Sub CalculadoraToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CalculadoraToolStripMenuItem.Click
        'Ejecutar la Calculadora
        Shell("C:\WINDOWS\system32\calc.exe", AppWinStyle.NormalFocus)
    End Sub
    Private Sub GuradarToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles GuradarToolStripMenuItem.Click
        SaveFileDialog1.ShowDialog()
    End Sub
    Private Sub AbrirToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AbrirToolStripMenuItem.Click
        OpenFileDialog1.ShowDialog()
    End Sub
    Private Sub SaveFileDialog1_FileOk(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles SaveFileDialog1.FileOk
        Dim writer As New IO.StreamWriter(SaveFileDialog1.FileName)
        If Me.TabControl2.SelectedTab Is TabPage5 Then
            writer.Write("*******Vertedor Rectangular************" & vbNewLine)
            writer.Write("Base del vertedor (b), m         " & vbNewLine & TextBox1.Text & vbNewLine)
            writer.Write("Base del canal (B), m            " & vbNewLine & TextBox2.Text & vbNewLine)
            writer.Write("Carga del vertedor (h), m        " & vbNewLine & TextBox3.Text & vbNewLine)
            writer.Write("Altura del vertedor (w), m       " & vbNewLine & TextBox4.Text & vbNewLine)
            writer.Write("Inclinación del vertedor, grados " & vbNewLine & TextBox5.Text & vbNewLine)
            writer.Write("**************Resultados**************" & vbNewLine)
            writer.Write("Coeficiente de descarga (cd)      " & vbNewLine & mu & vbNewLine)
            writer.Write("Gasto (Q), m^3/s                  " & vbNewLine & Q & vbNewLine)
        ElseIf Me.TabControl2.SelectedTab Is TabPage6 Then

        End If
        writer.Close()
    End Sub
    Private Sub OpenFileDialog1_FileOk(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk
        Dim reader As New IO.StreamReader(OpenFileDialog1.FileName)
        If Me.TabControl2.SelectedTab Is TabPage5 Then
            reader.ReadLine()
            reader.ReadLine()
            TextBox1.Text = reader.ReadLine
            reader.ReadLine()
            TextBox2.Text = reader.ReadLine
            reader.ReadLine()
            TextBox3.Text = reader.ReadLine
            reader.ReadLine()
            TextBox4.Text = reader.ReadLine
            reader.ReadLine()
            TextBox5.Text = reader.ReadLine
        ElseIf Me.TabControl2.SelectedTab Is TabPage6 Then
        End If
        reader.Close()
    End Sub
    '%-----------------------------------------  Bolqueo de teclas  --------------------------------
    '%Asc(46)= ".", Asc (13)= "enter", Asc(8)= "retroceso", Asc(3)= "ctrl+c (copiar)", Asc(22)="ctrl+v (pegar)", Asc (45)= "-", isnumber= numericos
    '%***********************************************************************************************
    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox2_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox2.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox3_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox3.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox4_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox4.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox5_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox5.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox8_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox8.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox9_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox9.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox12_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox12.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox13_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox13.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox14_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox14.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox15_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox15.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox19_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox19.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox20_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox20.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox24_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox24.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub TextBox25_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox25.KeyPress
        If Asc(e.KeyChar) <> 46 And Asc(e.KeyChar) <> 13 And Asc(e.KeyChar) <> 8 And Asc(e.KeyChar) <> 22 And Asc(e.KeyChar) <> 3 And Not Char.IsNumber(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub
    Private Sub ComboBox1_KeyPress(sender As Object, e As KeyPressEventArgs) Handles ComboBox1.KeyPress
        e.Handled = True
    End Sub
    Private Sub ComboBox2_KeyPress(sender As Object, e As KeyPressEventArgs) Handles ComboBox2.KeyPress
        e.Handled = True
    End Sub


End Class